//
//This contains code to change sounds from male to female depending on the thrower
class Brocconade expands FFWeapon config(FoodFight);

//First person
#exec MESH IMPORT MESH=BrocconadeAnimated ANIVFILE=MODELS\Br0cc0-n4TEAnimated4_a.3d DATAFILE=MODELS\Br0cc0-n4TEAnimated4_d.3d X=0 Y=0 Z=0 UnMirror=1
#exec MESH ORIGIN MESH=BrocconadeAnimated X=0 Y=0 Z=0 PITCH=0 ROLL=0 YAW=0
#exec MESH LODPARAMS MESH=BrocconadeAnimated STRENGTH=0

#exec MESH SEQUENCE MESH=BrocconadeAnimated SEQ=All 		STARTFRAME=0 	NUMFRAMES=64
#exec MESH SEQUENCE MESH=BrocconadeAnimated SEQ=Still 	STARTFRAME=0 	NUMFRAMES=1
#exec MESH SEQUENCE MESH=BrocconadeAnimated SEQ=Throw 	STARTFRAME=1 	NUMFRAMES=39
#exec MESH SEQUENCE MESH=BrocconadeAnimated SEQ=Select 	STARTFRAME=40 	NUMFRAMES=15
#exec MESH SEQUENCE MESH=BrocconadeAnimated SEQ=Down 		STARTFRAME=55 	NUMFRAMES=9

#exec MESHMAP NEW MESHMAP=BrocconadeAnimated MESH=BrocconadeAnimated
#exec MESHMAP SCALE MESHMAP=BrocconadeAnimated X=0.04 Y=0.04 Z=0.08

#exec TEXTURE IMPORT NAME=BrocconadeUVMap FILE=Textures/BrocconadeUVMap.bmp GROUP="Skins"  LODSET=2
#exec TEXTURE IMPORT NAME=SimpleGloveHandTexture FILE=Textures/SimpleGloveHandTexture.pcx GROUP=Skins FLAGS=2

#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeAnimated NUM=0 TEXTURE=BrocconadeUVMap
#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeAnimated NUM=1 TEXTURE=SimpleGloveHandTexture
#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeAnimated NUM=2 TEXTURE=SimpleGloveHandTexture
#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeAnimated NUM=3 TEXTURE=BrocconadeUVMap

//Used to add the grunt to the throwing subroutine
#exec MESH NOTIFY MESH=BrocconadeAnimated SEQ=Throw TIME=0.7 FUNCTION=AmIaBoyorGirl


//Pickup model
#exec MESH IMPORT MESH=Brocconade ANIVFILE=MODELS\Br0cc0-n4TE_a.3d DATAFILE=MODELS\Br0cc0-n4TE_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=Brocconade X=0 Y=0 Z=0 ROLL=-4
#exec MESH LODPARAMS MESH=Brocconade STRENGTH=0

#exec MESH SEQUENCE MESH=Brocconade SEQ=All 		STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=Brocconade SEQ=Still 	STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=Brocconade SEQ=Shoot 	STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=Brocconade SEQ=Select 	STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=Brocconade SEQ=Down 	STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW MESHMAP=Brocconade MESH=Brocconade
#exec MESHMAP SCALE MESHMAP=Brocconade X=0.02625 Y=0.02625 Z=0.0525

#exec MESHMAP SETTEXTURE MESHMAP=Brocconade NUM=0 TEXTURE=BrocconadeUVMap
#exec MESHMAP SETTEXTURE MESHMAP=Brocconade NUM=1 TEXTURE=BrocconadeUVMap
#exec MESHMAP SETTEXTURE MESHMAP=Brocconade NUM=2 TEXTURE=BrocconadeUVMap
#exec MESHMAP SETTEXTURE MESHMAP=Brocconade NUM=3 TEXTURE=BrocconadeUVMap

//Third person
#exec MESH IMPORT MESH=BrocconadeThird ANIVFILE=MODELS\Br0cc0-n4TE_a.3d DATAFILE=MODELS\Br0cc0-n4TE_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=BrocconadeThird X=0 Y=0 Z=-170 ROLL=-4
#exec MESH LODPARAMS MESH=BrocconadeThird STRENGTH=0

#exec MESH SEQUENCE MESH=BrocconadeThird SEQ=All 		STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=BrocconadeThird SEQ=Still 	STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=BrocconadeThird SEQ=Shoot 	STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=BrocconadeThird SEQ=Select 	STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=BrocconadeThird SEQ=Down 	STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW MESHMAP=BrocconadeThird MESH=BrocconadeThird
#exec MESHMAP SCALE MESHMAP=BrocconadeThird X=0.025 Y=0.025 Z=0.05

#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeThird NUM=0 TEXTURE=BrocconadeUVMap
#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeThird NUM=1 TEXTURE=BrocconadeUVMap
#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeThird NUM=2 TEXTURE=BrocconadeUVMap
#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeThird NUM=3 TEXTURE=BrocconadeUVMap

//HUD Tile
#exec TEXTURE IMPORT NAME=BroccHudTile FILE=Textures/BroccHudTile.BMP GROUP="Icons" MIPS=OFF

//Toss sound
#exec AUDIO IMPORT FILE="Sounds\RunAway.WAV" 	NAME=RunAway 		GROUP=Brocconade
#exec AUDIO IMPORT FILE="Sounds\Hallelujah.WAV" NAME=Hallelujah 	GROUP=Brocconade

function SetWeaponStay()
{
	bWeaponStay = false; // Brocconade never stays
}

function float RateSelf( out int bUseAltMode )
{
	local float EnemyDist;
	local bool bRetreating;
	local vector EnemyDir;

	if (AmmoType.AmmoAmount <=0)
		return -2;

	bUseAltMode = 0;

	if (Pawn(Owner).Enemy == None)
		return AIRating;

	EnemyDir = Pawn(Owner).Enemy.Location - Owner.Location;
	EnemyDist = VSize(EnemyDir);
	if (EnemyDist > 4000)
		return 0;

	bRetreating = (((EnemyDir/EnemyDist) Dot Owner.Velocity) < -0.6);
	if ((EnemyDist > 600) && (EnemyDir.Z > -0.4 * EnemyDist))
	{
		if (!bRetreating)
			return AIRating - 0.15;

		return AIRating;
	}

	if (bRetreating || (EnemyDir.Z < -0.7 * EnemyDist))
		return (AIRating + 0.18);
	return AIRating;
}

function Fire( float Value )
{
	if (AmmoType.UseAmmo(1))
	{
		PlayFiring();
		GoToState('NormalFire');
	}
}

function AltFire( float Value )
{
	if (AmmoType.UseAmmo(1))
	{
		PlayAltFiring();
		GotoState('AltFiring');
	}		
}

//This function changes the grunt throwing sound to male or female depending on the owner
function AmIaBoyorGirl()
{
	if(PlayerPawn(Owner) != none)
	{
		if (!playerpawn(Owner).PlayerReplicationInfo.bIsABot)  //human player
		{
			if (playerpawn(Owner).PlayerReplicationInfo.bIsFemale) //Female model
				Owner.PlaySound(sound'botpack.lland1', SLOT_None,Pawn(Owner).SoundDampening*4.0);
			else //must be male then
				Owner.PlaySound(sound'botpack.land01', SLOT_None,Pawn(Owner).SoundDampening*4.0);
		}
		else //player is a bot
		{
			if (playerpawn(Owner).PlayerReplicationInfo.bIsFemale) // female bot
				Owner.PlaySound(sound'botpack.lland1', SLOT_None,Pawn(Owner).SoundDampening*4.0);
			else  //must be a male bot then
				Owner.PlaySound(sound'botpack.land01', SLOT_None,Pawn(Owner).SoundDampening*4.0);
		}
		PlaySound(sound'RunAway');
	}
}

simulated function PlayFiring()
{
	PlayAnim('Throw',0.5);
}

simulated function PlayAltFiring()
{
	PlayAnim('Throw',0.5);
}

state NormalFire
{
	ignores Fire,AltFire;

	function AnimEnd()
	{
	}

Begin:
	FinishAnim();
	bPointing=True;
	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	TossIt();
	if (Owner.bHidden)
		CheckVisibility();
	Finish();
}

state AltFiring
{
	ignores Fire,AltFire;

	function AnimEnd()
	{
	}

Begin:
	FinishAnim();
	bPointing=True;
	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	TossItAlt();
	if (Owner.bHidden) 
		CheckVisibility();
	Finish();
}

function TossIt()
{
	ProjectileFire(ProjectileClass, AltProjectileSpeed, bAltWarnTarget);
}

function TossItAlt()
{
	ProjectileFire(AltProjectileClass, AltProjectileSpeed, bAltWarnTarget);
}

defaultproperties
{
	RespawnTime=60.000000
   WeaponDescription="Brocconator, the ultimate tossable veggie"
	AmmoName=Class'BroccAmmo'
	PickupAmmoCount=1
	bAltWarnTarget=True
	bRapidFire=False
	FiringSpeed=1.000000
	FireOffset=(X=15.000000,Y=-13.000000,Z=-7.000000)
   ProjectileClass=Class'BrocconadeFlying'
   AltProjectileClass=Class'BrocconadeFlyingAlt'
	AIRating=0.600000
   RefireRate=0.50000
   AltRefireRate=1.00000
   DeathMessage="%o was blasted by the Brocconade thrown by %k"
	AutoSwitchPriority=10
	InventoryGroup=10
	PickupMessage="You got the Brocconade!"
	ItemName="Brocconade"
	PlayerViewOffset=(X=20.00,Y=-10.00,Z=-4.00)
	PlayerViewMesh=BrocconadeAnimated
   BobDamping=0.972000
	PickupViewMesh=Brocconade
	ThirdPersonMesh=BrocconadeThird
	StatusIcon=BroccHudTile
   PickupSound=Sound'Hallelujah'
	Icon=BroccHudTile
	Mesh=Brocconade
	bNoSmooth=False
	CollisionRadius=12.00
	CollisionHeight=21.00
	bRotatingPickup=True
}
