//
//Small broc shards that come from the first explosion
class BrocconadeShard extends Projectile;

#exec MESH IMPORT MESH=BrocconadeShard ANIVFILE=MODELS\Br0cc0-n4TE-Shard_a.3d DATAFILE=MODELS\Br0cc0-n4TE-Shard_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=BrocconadeShard X=0 Y=0 Z=0
#exec MESH LODPARAMS MESH=BrocconadeShard STRENGTH=0

#exec MESH SEQUENCE MESH=BrocconadeShard SEQ=All 	STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=BrocconadeShard SEQ=Still STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW MESHMAP=BrocconadeShard MESH=BrocconadeShard
#exec MESHMAP SCALE MESHMAP=BrocconadeShard X=0.025 Y=0.025 Z=0.05

#exec MESHMAP SETTEXTURE MESHMAP=BrocconadeShard NUM=1 TEXTURE=BrocconadeUVMap

#exec AUDIO IMPORT FILE="Sounds\swish.WAV" NAME=swish

var bool bCanHitOwner, bHitWater, Detonating;
var float Count, SmokeRate;
var() bool CanHitInstigator;
var() float HitInstigatorTimeOut;

Replication
{
   UnReliable if (Role == ROLE_Authority)
      Detonating;
}

simulated function PostBeginPlay()
{
	local rotator RandRot;

	Super.PostBeginPlay();
	if (Level.NetMode != NM_DedicatedServer)
		PlayAnim('Still');
	SetTimer(1.0,true);
	Detonating= False;

	if (Role == ROLE_Authority)
	{
		RandRot = Rotation;
		RandRot.Pitch += FRand() * 2000 - 1000;
		RandRot.Yaw += FRand() * 2000 - 1000;
		RandRot.Roll += FRand() * 2000 - 1000;
		Velocity = Vector(RandRot) * (Speed + (FRand() * 200 - 100));
		if (Region.zone.bWaterZone)
			Velocity *= 0.65;
	}
	Super.PostBeginPlay();
}

simulated function ZoneChange(Zoneinfo NewZone)
{
	local waterring w;
	
	if (!NewZone.bWaterZone || bHitWater) Return;
	bHitWater = True;
	w = Spawn(class'WaterRing',,,,rot(16384,0,0));
	w.DrawScale = 0.2;
	w.RemoteRole = ROLE_None;
	Velocity=0.1*Velocity;
}

simulated function Tick(float DeltaTime)
{
	local SmallSpark2 c;

	if ( bHitWater || Level.bDropDetail )
	{
		Disable('Tick');
		Return;
	}
	if (FRand()<0.05)
	{
		c = Spawn(class'SmallSpark2');
		c.RemoteRole = ROLE_None;
	}
}

function Timer()
{
	if (LifeSpan <= 6) //turn it red
	{
		SetDisplayProperties(ERenderStyle.STY_Translucent,FireTexture'UnrealShare.Belt_fx.ShieldBelt.RedShield',true,true);
	}
	if (LifeSpan <= 5) //sound the alarm
	{
		AmbientSound=Sound'swish';
	}

	if (LifeSpan <= 4) //She's gonna blow
	{
		Detonating = True;
		Explosion(Location+Vect(0,0,1)*16);
	}
}

simulated function Landed(vector HitNormal)
{
	HitWall(HitNormal, None);
}

simulated function ProcessTouch(actor Other, vector HitLocation)
{
	if ((!CanHitInstigator || (CanHitInstigator && (Default.LifeSpan - LifeSpan) < HitInstigatorTimeOut)) && Other == Instigator)
		return;

	if ((Other!=instigator) || bCanHitOwner)
		Explosion(HitLocation);
}

simulated function HitWall(vector HitNormal, actor Wall)
{
	bCanHitOwner = True;
	Velocity = 0.8*(( Velocity dot HitNormal ) * HitNormal * (-2.0) + Velocity);   // Reflect off Wall w/damping
	RandSpin(100000);
	speed = VSize(Velocity);
	if (Level.NetMode != NM_DedicatedServer)
		PlaySound(ImpactSound, SLOT_Misc, 1.5 );
	if (Velocity.Z > 400)
		Velocity.Z = 0.5 * (400 + Velocity.Z);	
	else if (speed < 20)
	{
		bBounce = False;
		SetPhysics(PHYS_None);
	}
}

//Spawn explosion and brocc shards
function Explosion(vector HitLocation)
{
	HurtRadius(Damage,300.0, MyDamageType, MomentumTransfer, HitLocation );
   spawn(class'FFShockWave',,,HitLocation);
   RemoteRole = ROLE_SimulatedProxy;
	Destroy();
}

defaultproperties
{
	HitInstigatorTimeOut=0.500000
	CanHitInstigator=True
	speed=600.000000
	MaxSpeed=1000.000000
	Damage=100.000000
	LifeSpan=7.00000
	MomentumTransfer=50000
	MyDamageType=GrenadeDeath
	RemoteRole=ROLE_SimulatedProxy
   ImpactSound=Sound'gibP5'
   ExplosionDecal=Class'FFBlastMark'
	Physics=PHYS_Falling
	AnimSequence=Still
	Mesh=BrocconadeShard
	AmbientGlow=64
   bUnlit=True
	CollisionRadius=8.00
	CollisionHeight=8.00
	bNetTemporary=False
   DesiredRotation=(Pitch=12000,Yaw=5666,Roll=2334) //check me
	bNoSmooth=True
	bBounce=True
	bFixedRotationDir=True
	AmbientSound=Sound'UnrealShare.Steam'
	SoundPitch=64
   SoundRadius=120
   SoundVolume=150
}


