//
class BurgerCTFRulesCW extends FMCTFRulesClientWindow;

var UWindowCheckbox UsePreConfig;
var localized string PreConfigText, PreConfigHelp;

function Created()
{
	local int CenterWidth, CenterPos;

	CenterWidth = WinWidth * 3 / 4;
	CenterPos = (WinWidth - CenterWidth) / 2;
	
	Super.Created();
	
	Initialized = False;
	
	UsePreConfig = UWindowCheckbox(CreateControl(class'UWindowCheckbox', CenterPos, ControlOffset, CenterWidth, 1));
	UsePreConfig.SetText(PreConfigText);
	UsePreConfig.SetHelpText(PreConfigHelp);
	UsePreConfig.SetFont(F_Normal);
	UsePreConfig.Align = TA_Right;
	UsePreConfig.bChecked = class'BurgerCTFMapSetup'.default.bUseFlagPreConfig;
	
	ControlOffset += 25;
	FFSlider.WinTop += 25;
	
	Initialized = True;
}

function BeforePaint(Canvas C, float X, float Y)
{
	local int CenterWidth, CenterPos;
	
	CenterWidth = WinWidth * 3 / 4;
	CenterPos = (WinWidth - CenterWidth) / 2;
	
	Super.BeforePaint(C, X, Y);
	
	UsePreConfig.SetSize(CenterWidth, 1);
	UsePreConfig.WinLeft = CenterPos;
}

function Notify(UWindowDialogControl C, byte E)
{
	if ( !Initialized )
		return;
	
	Super.Notify(C, E);
	
	switch(E) 
	{
	case DE_Change:
		switch (C) 
		{
			case UsePreConfig:
				AnnounceChanged();
				break;
		}
	}
}

function PreConfigChanged()
{
	class'BurgerCTFMapSetup'.Default.bUseFlagPreConfig = UsePreConfig.bChecked;
	class'BurgerCTFMapSetup'.static.StaticSaveConfig();
}

defaultproperties
{
   PreConfigText="Use map settings for burger placement"
   PreConfigHelp="Use the locations stored for the map to place the burger. (recommended)"
}
