//
//main point of this class is to identify the person holding the flag
class BurgerCTFScoreboard extends UnrealCTFScoreboard;

var color MyPurpleColor;

function ShowScores( canvas Canvas )
{
	local PlayerReplicationInfo PRI;
	local int PlayerCount, i;
	local float LoopCountTeam[2];
	local float XL, YL, XOffset, YOffset, XStart;
	local int PlayerCounts[2];
	local font CanvasFont;
	local bool bCompressed;
	local float r;
	
	OwnerInfo = Pawn(Owner).PlayerReplicationInfo;
	OwnerGame = TournamentGameReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);	
	Canvas.Style = ERenderStyle.STY_Normal;
	CanvasFont = Canvas.Font;
	
	// Header
	DrawHeader(Canvas);
	
	for (i = 0; i < 32; i++)
		Ordered[i] = None;
	
	for (i = 0; i < 32; i++) 
	{
		if ( PlayerPawn(Owner).GameReplicationInfo.PRIArray[i] != None ) 
		{
			PRI = PlayerPawn(Owner).GameReplicationInfo.PRIArray[i];
			if ( PRI.Team < 2 && (!PRI.bIsSpectator || PRI.bWaitingPlayer) ) 
			{
				Ordered[PlayerCount] = PRI;
				PlayerCount++;
				PlayerCounts[PRI.Team]++;
			}
		}
	}
	
	SortScores(PlayerCount);
	Canvas.Font = MyFonts.GetMediumFont( Canvas.ClipX );
	Canvas.StrLen("TEXT", XL, YL);
	ScoreStart = Canvas.CurY + YL * 2;
	if ( ScoreStart + PlayerCount * YL + 2 > Canvas.ClipY ) 
	{
		bCompressed = true;
		CanvasFont = Canvas.Font;
		Canvas.Font = font'SmallFont';
		r = YL;
		Canvas.StrLen("TEXT", XL, YL);
		r = YL / r;
		Canvas.Font = CanvasFont;
	}
	
	for (I = 0; I < PlayerCount; I++) 
	{
		if ( Ordered[I].Team < 2 ) 
		{
			if ( Ordered[I].Team == 0 )
				XOffset = (Canvas.ClipX / 4) - (Canvas.ClipX / 8);
			else
				XOffset = (Canvas.ClipX * 3 / 4) - (Canvas.ClipX / 8);
			
			Canvas.StrLen("TEXT", XL, YL);
			Canvas.DrawColor = AltTeamColor[Ordered[I].Team];
			YOffset = ScoreStart + (LoopCountTeam[Ordered[I].Team] * YL) + 2;

			// Draw Name and Ping
			DrawNameAndPing(Canvas, Ordered[I], XOffset, YOffset, bCompressed);
			if ( bCompressed )
				LoopCountTeam[Ordered[I].Team] += 1;
			else
				LoopCountTeam[Ordered[I].Team] += 2;
		}
	}
	
	for (i = 0; i < 2; i++) 
	{
		Canvas.Font = MyFonts.GetMediumFont(Canvas.ClipX);
		if ( PlayerCounts[i] > 0 ) 
		{
			if ( i == 0 )
				XOffset = (Canvas.ClipX / 4) - (Canvas.ClipX / 8);
			else
				XOffset = (Canvas.ClipX * 3 / 4) - (Canvas.ClipX / 8);
			YOffset = ScoreStart - YL + 2;
			
			Canvas.DrawColor = TeamColor[i];
			Canvas.SetPos(XOffset, YOffset);
			Canvas.StrLen(TeamName[i], XL, YL);
			Canvas.DrawText(TeamName[i], false);
			Canvas.StrLen(int(OwnerGame.Teams[i].Score), XL, YL);
			Canvas.SetPos(XOffset + Canvas.ClipX / 4 - XL, YOffset);
			Canvas.DrawText(int(OwnerGame.Teams[i].Score), false);
			
			if ( PlayerCounts[i] > 4 ) 
			{
				if ( i < 2 )
					YOffset = ScoreStart + YL * 8;
				else
					YOffset = ScoreStart + YL * 19;
				Canvas.Font = MyFonts.GetSmallFont(Canvas.ClipX);
				Canvas.SetPos(XOffset, YOffset);
			}
		}
	}

	// Trailer
	if ( !Level.bLowRes ) 
	{
		Canvas.Font = MyFonts.GetSmallFont(Canvas.ClipX);
		DrawTrailer(Canvas);
	}
	Canvas.Font = CanvasFont;
	Canvas.DrawColor = WhiteColor;
}

function DrawNameAndPing(Canvas Canvas, PlayerReplicationInfo PRI, float XOffset, float YOffset, bool bCompressed)
{
   local float XL, YL, XL2, YL2, YB;
   local BotReplicationInfo BRI;
   local String S, O, L;
   local Font CanvasFont;
   local bool bAdminPlayer;
   local PlayerPawn PlayerOwner;
   local int Time;

   PlayerOwner = PlayerPawn(Owner);

   bAdminPlayer = PRI.bAdmin;

   // Draw Name
   if (PRI.PlayerName == PlayerOwner.PlayerReplicationInfo.PlayerName)
      Canvas.DrawColor = GoldColor;

	//logged in admin will be white
   if (bAdminPlayer)
      Canvas.DrawColor = WhiteColor;

	//flag carrier will have purple name in scoreboard
	if (PRI.HasFlag != None)
		Canvas.DrawColor = MyPurpleColor;

   Canvas.SetPos(XOffset, YOffset);
   Canvas.DrawText(PRI.PlayerName, False);
   Canvas.StrLen(PRI.PlayerName, XL, YB);

   if (Canvas.ClipX > 512)
   {
      CanvasFont = Canvas.Font;
      Canvas.Font = Font'SmallFont';
      Canvas.DrawColor = WhiteColor;

      if (Level.NetMode != NM_Standalone)
      {
         if (!bCompressed || (Canvas.ClipX > 640))
         {
            // Draw Time
            Time = Max(1, (Level.TimeSeconds + PlayerOwner.PlayerReplicationInfo.StartTime - PRI.StartTime)/60);
            Canvas.StrLen(TimeString$":     ", XL, YL);
            Canvas.SetPos(XOffset - XL - 6, YOffset);
            Canvas.DrawText(TimeString$":"@Time, false);
         }

         // Draw Ping
         Canvas.StrLen(PingString$":     ", XL2, YL2);
         Canvas.SetPos(XOffset - XL2 - 6, YOffset + (YL+1));
         Canvas.DrawText(PingString$":"@PRI.Ping, false);
      }
      Canvas.Font = CanvasFont;
   }

   // Draw Score
   if (PRI.PlayerName == PlayerOwner.PlayerReplicationInfo.PlayerName)
      Canvas.DrawColor = GoldColor;
   else
      Canvas.DrawColor = TeamColor[PRI.Team];
   DrawScore(Canvas, PRI.Score, XOffset, YOffset);

   if (Canvas.ClipX < 512)
      return;

   // Draw location, Order
   if (!bCompressed && (PRI.Team == OwnerInfo.Team))
   {
      CanvasFont = Canvas.Font;
      Canvas.Font = Font'SmallFont';

      if (PRI.PlayerLocation != None)
         L = PRI.PlayerLocation.LocationName;
      else if (PRI.PlayerZone != None)
         L = PRI.PlayerZone.ZoneName;
      else
         L = "";
      if (L != "")
      {
         L = InString@L;
         Canvas.SetPos(XOffset, YOffset + YB);
         Canvas.DrawText(L, False);
      }
      O = OwnerGame.GetOrderString(PRI);
      if (O != "")
      {
         O = OrdersString@O;
         Canvas.StrLen(O, XL2, YL2);
         Canvas.SetPos(XOffset, YOffset + YB + YL2);
         Canvas.DrawText(O, False);
      }
      Canvas.Font = CanvasFont;
   }
}

function DrawTrailer(canvas Canvas)
{
	local int Hours, Minutes, Seconds;
	local float XL, YL;
	local PlayerPawn PlayerOwner;
	
	Canvas.bCenter = true;
	Canvas.StrLen("Test", XL, YL);
	Canvas.DrawColor = WhiteColor;
	PlayerOwner = PlayerPawn(Owner);
	Canvas.SetPos(0, Canvas.ClipY - 2 * YL);
	if (Level.NetMode == NM_Standalone && Level.Game.IsA('DeathMatchPlus'))
	{
		if (DeathMatchPlus(Level.Game).bRatedGame)
			Canvas.DrawText(DeathMatchPlus(Level.Game).RatedGameLadderObj.SkillText@BurgerReplicationInfo(PlayerOwner.GameReplicationInfo).RealGameName@MapTitle@MapTitleQuote$Level.Title$MapTitleQuote, true);
		else if (DeathMatchPlus(Level.Game).bNoviceMode)
			Canvas.DrawText(class'ChallengeBotInfo'.default.Skills[Level.Game.Difficulty]@BurgerReplicationInfo(PlayerOwner.GameReplicationInfo).RealGameName@MapTitle@MapTitleQuote$Level.Title$MapTitleQuote, true);
		else  
			Canvas.DrawText(class'ChallengeBotInfo'.default.Skills[Level.Game.Difficulty + 4]@BurgerReplicationInfo(PlayerOwner.GameReplicationInfo).RealGameName@MapTitle@MapTitleQuote$Level.Title$MapTitleQuote, true);
	}
	else
		Canvas.DrawText(BurgerReplicationInfo(PlayerOwner.GameReplicationInfo).RealGameName@MapTitle@Level.Title, true);

	Canvas.SetPos(0, Canvas.ClipY - YL);
	if (bTimeDown || PlayerOwner.GameReplicationInfo.RemainingTime > 0)
	{
		bTimeDown = true;
		if (PlayerOwner.GameReplicationInfo.RemainingTime <= 0)
			Canvas.DrawText(RemainingTime @ "00:00", true);
		else 
		{
			Minutes = PlayerOwner.GameReplicationInfo.RemainingTime / 60;
			Seconds = PlayerOwner.GameReplicationInfo.RemainingTime % 60;
			Canvas.DrawText(RemainingTime @ TwoDigitString(Minutes) $ ":" $ TwoDigitString(Seconds), true);
		}
	}
	else 
	{
		Seconds = PlayerOwner.GameReplicationInfo.ElapsedTime;
		Minutes = Seconds / 60;
		Hours   = Minutes / 60;
		Seconds = Seconds - (Minutes * 60);
		Minutes = Minutes - (Hours * 60);
		Canvas.DrawText(ElapsedTime @ TwoDigitString(Hours) $ ":" $ TwoDigitString(Minutes) $ ":" $ TwoDigitString(Seconds), true);
	}

	if (PlayerOwner.GameReplicationInfo.GameEndedComments != "")
	{
		Canvas.bCenter = true;
		Canvas.StrLen("Test", XL, YL);
		Canvas.SetPos(0, Canvas.ClipY - Min(YL * 6, Canvas.ClipY * 0.1));
		Canvas.DrawColor = GreenColor;
		if ( Level.NetMode == NM_Standalone )
			Canvas.DrawText(Ended @ Continue, true);
		else
			Canvas.DrawText(Ended, true);
	}
	else if (PlayerOwner != None && PlayerOwner.Health <= 0)
	{
		Canvas.bCenter = true;
		Canvas.StrLen("Test", XL, YL);
		Canvas.SetPos(0, Canvas.ClipY - Min(YL * 6, Canvas.ClipY * 0.1));
		Canvas.DrawColor = GreenColor;
		Canvas.DrawText(Restart, true);
	}
	Canvas.bCenter = false;
}

function DrawVictoryConditions(Canvas Canvas)
{
	local BurgerReplicationInfo OFGRI;
	local float XL, YL;

	OFGRI = BurgerReplicationInfo(PlayerPawn(Owner).GameReplicationInfo);
	if (OFGRI == None)
		return;

	Canvas.DrawText(OFGRI.RealGameName);
	Canvas.StrLen("Test", XL, YL);
	Canvas.SetPos(0, Canvas.CurY - YL);

	if (OFGRI.FragLimit > 0)
	{
		Canvas.DrawText(FragGoal@OFGRI.FragLimit);
		Canvas.StrLen("Test", XL, YL);
		Canvas.SetPos(0, Canvas.CurY - YL);
	}

	if (OFGRI.TimeLimit > 0)
		Canvas.DrawText(TimeLimit@OFGRI.TimeLimit$":00");
}

defaultproperties
{
   TeamName(3)="Flags"
   MyPurpleColor=(R=255,B=255)
}
