//
//Handler for the various messages played during a BurgerCTF game
class BurgerMessage extends CriticalEventPlus;

var localized string NeutralFlagReturned, CapturedFlag, CapturedFlagTeamTrailor,
	DroppedFlag, TeamHasFlag;

static function string GetString(
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
	)
{
	switch (Switch)
	{
		// Flag was captured.
		case 0:
			if ( RelatedPRI_1 == None )
				return "";
			if ( TeamInfo(OptionalObject) == None )
				return "";
			return RelatedPRI_1.PlayerName$Default.CapturedFlag$TeamInfo(OptionalObject).TeamName$Default.CapturedFlagTeamTrailor;
			break;

		// Flag returned.
		case 1:
			if ( NeutralFlag(OptionalObject) == None )
				return "";
			else
				return Default.NeutralFlagReturned;
			break;

		// Flag was dropped.
		case 2:
			if ( RelatedPRI_1 == None )
				return "";
			return RelatedPRI_1.PlayerName@Default.DroppedFlag;
			break;

		// Flag was picked up.
		case 3:
			if ( RelatedPRI_1 == None )
				return "";
			if ( TeamInfo(OptionalObject) == None )
				return "";

			return RelatedPRI_1.PlayerName@"["$TeamInfo(OptionalObject).TeamName$"]"@Default.TeamHasFlag;
			break;
	}
	return "";
}

defaultproperties
{
   NeutralFlagReturned="The burger bomb returned!"
   CapturedFlag=" delivers the burger bomb, "
   CapturedFlagTeamTrailor=" scores !"
   DroppedFlag="dropped the burger bomb!"
   TeamHasFlag="has the burger bomb!"
}
