//
//This is the carrot stuck in the wall
class CarrotStuck extends Decoration config(FoodFight);

var() int Health;
var config int CarrotHealth;

function PostBeginPlay()
{
	if(Region.Zone.bWaterZone && (Buoyancy > Mass))
	{
		SetPhysics(PHYS_Falling);
      bBobbing = true;
      if(Buoyancy > 1.1 * Mass)
         Buoyancy = 0.95 * Buoyancy; // waterlog
      else if(Buoyancy > 1.03 * Mass)
         Buoyancy = 0.99 * Buoyancy;
   }
   if (Region.Zone.bDestructive)
	{
		spawn(class'UT_SpriteSmokePuff',,,Location);
      Destroy();
   }
}

Auto State Animate
{
   function HitWall (vector HitNormal, actor Wall)
   {
      if (Velocity.Z<-200)
		  	TakeDamage(100,Pawn(Owner),HitNormal,HitNormal*10000,'shattered');
      bBounce = False;
      Velocity = vect(0,0,0);
   }

	//carrots can be destroyed
	function TakeDamage( int NDamage, Pawn instigatedBy, Vector hitlocation, Vector momentum, name damageType)
   {
      Instigator = InstigatedBy;
      bBobbing = false;
      if (CarrotHealth<0)
			Return;
      if (Instigator != None)
         MakeNoise(1.0);
      CarrotHealth -= NDamage;
      if (CarrotHealth <0)
      {
         Frag(class'CarrotFragments',Momentum,0.6,10);
         Self.Destroy();
      }
   }
Begin:
}

//carrots were given a lifespan because they tended to clutter maps up eventually and create some lag
defaultproperties
{
	CarrotHealth=100
   CollisionRadius=+0020.000000
   CollisionHeight=+00008.000000
   LifeSpan=120.000000
   DrawType=DT_Mesh
   Physics=PHYS_Flying
   Mesh=Mesh'CarrotProjectile'
 	Health=100
   bPushable=False 
   bStatic=False
   bCollideActors=True
   bCollideWorld=True
   bBlockActors=True
   bBlockPlayers=True
   Mass=50.000000
   Buoyancy=100.000000
}