//
//this is the green fart cloud
class EffectParticle expands Effects config(FoodFight);

#exec TEXTURE IMPORT NAME=Fart FILE=Textures\Fart.bmp GROUP=Effects

var bool bFadeOut;
var bool bShrink;
var bool bGrow;
var int TouchCount;
var float GrowRate;
var config int FartDamage;
var config float FartLife;
var config float FartLifeVar;

simulated function PostBeginPlay()
{
	//variance to lifespan
	LifeSpan = FartLife + (FRand() * FartLifeVar);
}

simulated function Landed(vector HitNormal)
{
	HitWall(HitNormal, None);
}

simulated function HitWall(vector HitNormal, actor Wall)
{
	Velocity = 0.8*(( Velocity dot HitNormal ) * HitNormal * (-2.0) + Velocity);
}

simulated function Tick(float DeltaTime)
{
	if (bFadeOut)
		ScaleGlow = (Lifespan/Default.Lifespan);
	if (bShrink)
		DrawScale = (Lifespan/DrawScale);
	if (bGrow)
		DrawScale += GrowRate;
}

simulated function Touch(actor Other)
{
	if (!Other.IsA('EffectParticle'))
	{
		//only hurt other team
		if (Other.IsA('Pawn') && (Other != Owner) &&  (Pawn(Owner).PlayerReplicationInfo.Team != Pawn(Other).PlayerReplicationInfo.Team))
		{
			Other.TakeDamage(FartDamage, None, Location, Velocity, 'Drowned');
			//destroy the fart cloud, it did it's damage
			Destroy();
		}
		Velocity += Other.Velocity / 15;
	}
}

defaultproperties
{
   Physics=PHYS_Falling
   RemoteRole=ROLE_SimulatedProxy
	FartLife=8.00
	FartLifeVar=4.00
   DrawType=DT_Sprite
   Style=STY_Translucent
   Texture=Texture'Fart'
   CollisionRadius=20.00
   CollisionHeight=20.00
   bCollideActors=True
   bCollideWorld=True
   FartDamage=1
}