//
//This exists solely so I can intercept the serverinfo class
class FFHUD expands ChallengeHUD;

#exec TEXTURE IMPORT NAME=HUDWeaponsA FILE=TEXTURES\HUDWeaponsA.bmp GROUP="Icons" MIPS=OFF FLAGS=2
#exec TEXTURE IMPORT NAME=poisonmask FILE=TEXTURES\poisonmask.bmp GROUP="Masks" FLAGS=2

#exec OBJ LOAD FILE=..\TEXTURES\FoodFightTextures.utx PACKAGE=FoodFight.Addons

var PlayerPawn Player;
var GameReplicationInfo GRI;
var int RespawnTimer;
var PlayerReplicationInfo Ordered[32];

simulated function PostBeginPlay ()
{
   Super.PostBeginPlay();
   Level.bHighDetailMode = true;
   RespawnTimer=0;
   SetTimer(0.50,True);
}

function Timer ()
{
   local int i, j;

   if (PawnOwner.IsInState('Dying') && RespawnTimer==0) // delay the respawn so player can see SB
      RespawnTimer=10*2; // 10 sec
   else if (PawnOwner.IsInState('Dying') && RespawnTimer>0)
   {
      if (--RespawnTimer == 0)
         PlayerPawn(PawnOwner).ServerRestartPlayer();
   }
   if (!bDrawMessageArea)
   {
      if (MessageFadeCount > 0)
         MessageFadeCount--;
   }
   for (i=0; i<4; i++)
   {
      if ((ShortMessageQueue[i].Message != None) && (Level.TimeSeconds >= ShortMessageQueue[i].EndOfLife))
         ClearMessage(ShortMessageQueue[i]);
   }
   for (i=0; i<3; i++)
   {
      if (ShortMessageQueue[i].Message == None)
      {
         for (j=i; j<4; j++)
         {
            if (ShortMessageQueue[j].Message != None)
            {
               CopyMessage(ShortMessageQueue[i],ShortMessageQueue[j]);
               ClearMessage(ShortMessageQueue[j]);
               break;
            }
         }
      }
   }
   for (i=0; i<10; i++)
   {
      if ((LocalMessages[i].Message != None) && (Level.TimeSeconds >= LocalMessages[i].EndOfLife))
         ClearMessage(LocalMessages[i]);
   }
   for (i=0; i<9; i++)
   {
      if (LocalMessages[i].Message == None)
      {
         CopyMessage(LocalMessages[i],LocalMessages[i+1]);
         ClearMessage(LocalMessages[i+1]);
      }
   }
   if ((PlayerOwner == None) || (PawnOwner == None) || (PlayerOwner.GameReplicationInfo == None) || (PawnOwner.PlayerReplicationInfo == None))
      return;
      
   UpdateRankAndSpread();
}

function UpdateRankAndSpread()
{
   local PlayerReplicationInfo PRI;
   local int HighScore;
   local int i, j;

   PlayerCount = 0;
   HighScore = -100;
   bTiedScore = False;
   Rank = 1;
   for (i=0; i<32; i++)
   {
      PRI = PlayerOwner.GameReplicationInfo.PRIArray[i];
      if ((PRI != None) && (!PRI.bIsSpectator || PRI.bWaitingPlayer))
      {
         PlayerCount++;
         if (PRI != PawnOwner.PlayerReplicationInfo)
         {
            if (PRI.Score > PawnOwner.PlayerReplicationInfo.Score)
               Rank += 1;
            else if (PRI.Score == PawnOwner.PlayerReplicationInfo.Score)
            {
               bTiedScore = True;
               if (PRI.Deaths < PawnOwner.PlayerReplicationInfo.Deaths)
                  Rank += 1;
               else if (PRI.Deaths == PawnOwner.PlayerReplicationInfo.Deaths)
                  if (PRI.PlayerID < PawnOwner.PlayerReplicationInfo.PlayerID)
                     Rank += 1;
            }
            if (PRI.Score > HighScore)
               HighScore = PRI.Score;
         }
      }
   }
   Lead = int(PawnOwner.PlayerReplicationInfo.Score) - HighScore;
}

simulated function DrawStatus(Canvas Canvas)
{
   local float StatScale, ChestAmount, ThighAmount, H1, H2, X, Y, DamageTime;
   Local int ArmorAmount,CurAbs,i;
   Local inventory Inv,BestArmor;
   local bool bChestArmor, bShieldbelt, bThighArmor, bJumpBoots, bHasDoll;
   local Bot BotOwner;
   local TournamentPlayer TPOwner;
   local texture Doll, DollBelt;

   ArmorAmount = 0;
   CurAbs = 0;
   i = 0;
   BestArmor=None;
   for(Inv=PawnOwner.Inventory; Inv!=None; Inv=Inv.Inventory)
   {
      if (Inv.bIsAnArmor)
      {
         if (Inv.IsA('Antacid'))
            bShieldbelt = true;
         else if (Inv.IsA('Apron'))
         {
            ThighAmount += Inv.Charge;
            bThighArmor = true;
         }
         else
         {
            bChestArmor = true;
            ChestAmount += Inv.Charge;
         }
         ArmorAmount += Inv.Charge;
      }
      else if (Inv.IsA('UT_JumpBoots'))
         bJumpBoots = true;
      else
      {
         i++;
         if (i > 100)
            break; // can occasionally get temporary loops in netplay
      }
   }

   if (!bHideStatus)
   {
      TPOwner = TournamentPlayer(PawnOwner);
      if (Canvas.ClipX < 400)
         bHasDoll = false;
      else if (TPOwner != None)
      {
         Doll = TPOwner.StatusDoll;
         DollBelt = TPOwner.StatusBelt;
         bHasDoll = true;
      }
      else
      {
         BotOwner = Bot(PawnOwner);
         if (BotOwner != None)
         {
            Doll = BotOwner.StatusDoll;
            DollBelt = BotOwner.StatusBelt;
            bHasDoll = true;
         }
      }
      if (bHasDoll)
      {
         Canvas.Style = ERenderStyle.STY_Translucent;
         StatScale = Scale * StatusScale;
         X = Canvas.ClipX - 128 * StatScale;
         Canvas.SetPos(X, 0);
         if (PawnOwner.DamageScaling > 2.0)
            Canvas.DrawColor = PurpleColor;
         else
            Canvas.DrawColor = HUDColor;
         Canvas.DrawTile(Doll, 128*StatScale, 256*StatScale, 0, 0, 128.0, 256.0);
         Canvas.DrawColor = HUDColor;
         if (bShieldBelt)
         {
            Canvas.DrawColor = BaseColor;
            Canvas.DrawColor.B = 0;
            Canvas.SetPos(X, 0);
            Canvas.DrawIcon(DollBelt, StatScale);
         }
         if (bChestArmor)
         {
            ChestAmount = FMin(0.01 * ChestAmount,1);
            Canvas.DrawColor = HUDColor * ChestAmount;
            Canvas.SetPos(X, 0);
            Canvas.DrawTile(Doll, 128*StatScale, 64*StatScale, 128, 0, 128, 64);
         }
         if (bThighArmor)
         {
            ThighAmount = FMin(0.02 * ThighAmount,1);
            Canvas.DrawColor = HUDColor * ThighAmount;
            Canvas.SetPos(X, 64*StatScale);
            Canvas.DrawTile(Doll, 128*StatScale, 64*StatScale, 128, 64, 128, 64);
         }
         if (bJumpBoots)
         {
            Canvas.DrawColor = HUDColor;
            Canvas.SetPos(X, 128*StatScale);
            Canvas.DrawTile(Doll, 128*StatScale, 64*StatScale, 128, 128, 128, 64);
         }
         Canvas.Style = Style;
         if ((PawnOwner == PlayerOwner) && Level.bHighDetailMode && !Level.bDropDetail)
         {
            for (i=0; i<4; i++)
            {
               DamageTime = Level.TimeSeconds - HitTime[i];
               if (DamageTime < 1)
               {
                  Canvas.SetPos(X + HitPos[i].X * StatScale, HitPos[i].Y * StatScale);
                  if ((HUDColor.G > 100) || (HUDColor.B > 100))
                     Canvas.DrawColor = RedColor;
                  else
                     Canvas.DrawColor = (WhiteColor - HudColor) * FMin(1, 2 * DamageTime);
                     Canvas.DrawColor.R = 255 * FMin(1, 2 * DamageTime);
                     Canvas.DrawTile(Texture'BotPack.HudElements1', StatScale * HitDamage[i] * 25, StatScale * HitDamage[i] * 64, 0, 64, 25.0, 64.0);
               }
            }
         }
      }
   }
   Canvas.DrawColor = HUDColor;
   if (bHideStatus && bHideAllWeapons)
   {
      X = 0.5 * Canvas.ClipX;
      Y = Canvas.ClipY - 64 * Scale;
   }
   else
   {
      X = Canvas.ClipX - 128 * StatScale - 140 * Scale;
      Y = 64 * Scale;
   }
   Canvas.SetPos(X,Y);
   if (PawnOwner.Health < 50)
   {
      H1 = 1.5 * TutIconBlink;
      H2 = 1 - H1;
      Canvas.DrawColor = WhiteColor * H2 + (HUDColor - WhiteColor) * H1;
   }
   else
      Canvas.DrawColor = HUDColor;
   Canvas.DrawTile(Texture'BotPack.HudElements1', 128*Scale, 64*Scale, 128, 128, 128.0, 64.0);

   if (PawnOwner.Health < 50)
   {
      H1 = 1.5 * TutIconBlink;
      H2 = 1 - H1;
      Canvas.DrawColor = Canvas.DrawColor * H2 + (WhiteColor - Canvas.DrawColor) * H1;
   }
   else
      Canvas.DrawColor = WhiteColor;

   DrawBigNum(Canvas, Max(0, PawnOwner.Health), X + 4 * Scale, Y + 16 * Scale, 1);

   Canvas.DrawColor = HUDColor;
   if (bHideStatus && bHideAllWeapons)
   {
      X = 0.5 * Canvas.ClipX - 128 * Scale;
      Y = Canvas.ClipY - 64 * Scale;
   }
   else
   {
      X = Canvas.ClipX - 128 * StatScale - 140 * Scale;
      Y = 0;
   }
   Canvas.SetPos(X, Y);
   Canvas.DrawTile(Texture'BotPack.HudElements1', 128*Scale, 64*Scale, 0, 192, 128.0, 64.0);
   if (bHideStatus && bShieldBelt)
      Canvas.DrawColor = GoldColor;
   else
      Canvas.DrawColor = WhiteColor;
   DrawBigNum(Canvas, Min(150,ArmorAmount), X + 4 * Scale, Y + 16 * Scale, 1);

	//peppermill effect
   if (PlayerIsPeppered())
   {
      Canvas.Style = ERenderStyle.STY_Translucent;

      Canvas.SetPos(0.0,0.0);
      Canvas.DrawRect(Texture'poisonmask', Canvas.ClipX, Canvas.ClipY);
   	//first row
      Canvas.SetPos(0.0,0.0);
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(Canvas.ClipX / 4.0 ,0.0);
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(2*(Canvas.ClipX / 4.0) ,0.0);
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(3*(Canvas.ClipX / 4.0) ,0.0);
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(0.0, Canvas.ClipY / 3.0);
      //second row
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(Canvas.ClipX / 4.0 ,Canvas.ClipY / 3.0);
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(2*(Canvas.ClipX / 4.0) ,Canvas.ClipY / 3.0);
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(3*(Canvas.ClipX / 4.0) , Canvas.ClipY / 3.0);
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(0.0, 2*(Canvas.ClipY / 3.0));
      //third row
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(Canvas.ClipX / 4.0 , 2*(Canvas.ClipY / 3.0));
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(2*(Canvas.ClipX / 4.0) , 2*(Canvas.ClipY / 3.0));
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
      Canvas.SetPos(3*(Canvas.ClipX / 4.0) , 2*(Canvas.ClipY / 3.0));
      Canvas.DrawRect(Texture'FoodFight.Addons.Peppermill.PepperHUD', Canvas.ClipX / 4.0 , Canvas.ClipY / 3.0);
   }
}

simulated function bool PlayerIsPeppered()
{
   local PepperEffect PE;

   PE = PepperEffect(PlayerOwner.FindInventoryType(class'PepperEffect'));
   if ((PE == None) || !(PE.bPepperActive))
      return false;
   else
      return true;
}

//Replaces the stock weapon bar with FF tiles
simulated function DrawWeapons(Canvas Canvas)
{
    local Weapon W, WeaponSlot[11];
    local inventory Inv;
    local int i, j, BaseY, BaseX, Pending, WeapX, WeapY;
    local float AmmoScale, WeaponOffset, WeapScale, WeaponX, TexX, TexY;

    BaseX = 0.5 * (Canvas.ClipX - HudScale * WeaponScale * Canvas.ClipX);
    WeapScale = WeaponScale * Scale;
    Canvas.Style = Style;
    BaseY = Canvas.ClipY - 63.5 * WeapScale;
    WeaponOffset = 0.1 * HUDScale * WeaponScale * Canvas.ClipX;

    if ( PawnOwner.Weapon != None )
    {
        W = PawnOwner.Weapon;
        if ((Opacity > 8) || !Level.bHighDetailMode)
            Canvas.Style = ERenderStyle.STY_Normal;
        WeaponX = BaseX + (W.InventoryGroup - 1) * WeaponOffset;
        Canvas.CurX = WeaponX;
        Canvas.CurY = BaseY;
        Canvas.DrawColor = SolidHUDColor;
        Canvas.DrawIcon(W.StatusIcon, WeapScale);
        Canvas.DrawColor = GoldColor;
        Canvas.CurX = WeaponX + 4 * WeapScale;
        Canvas.CurY = BaseY + 4 * WeapScale;
        Canvas.Style = Style;
        if ( W.InventoryGroup == 10 )
            Canvas.DrawTile(Texture'BotPack.HudElements1', 0.75 * WeapScale * 25, 0.75 * WeapScale * 64, 0, 0, 25.0, 64.0);
        else
            Canvas.DrawTile(Texture'BotPack.HudElements1', 0.75 * WeapScale * 25, 0.75 * WeapScale * 64, 25*W.InventoryGroup, 0, 25.0, 64.0);

        WeaponSlot[W.InventoryGroup] = W;  
        Canvas.CurX = WeaponX;
        Canvas.CurY = BaseY;
        Canvas.DrawTile(Texture'HUDWeaponsA', 128 * WeapScale, 64 * WeapScale, 128, 64, 128, 64);
    }
    if (Level.bHighDetailMode && (PawnOwner.PendingWeapon != None))
    {
        Pending = PawnOwner.PendingWeapon.InventoryGroup;
        Canvas.CurX = BaseX + (Pending - 1) * WeaponOffset - 64 * WeapScale;
        Canvas.CurY = Canvas.ClipY - 96 * WeapScale; 
        Canvas.Style = ERenderStyle.STY_Translucent;
        Canvas.DrawColor = GoldColor;
        Canvas.DrawTile(Texture'HUDWeaponsA', 256 * WeapScale, 128 * WeapScale, 0, 128, 256.0, 128.0);
    }
    else
        Pending = 100;

    Canvas.Style = Style;
    i = 0;
    for (Inv=PawnOwner.Inventory; Inv!=None; Inv=Inv.Inventory)
    {
        if (Inv.IsA('Weapon') && (Inv != PawnOwner.Weapon))
        {
            W = Weapon(Inv);
            if ( WeaponSlot[W.InventoryGroup] == None )
                WeaponSlot[W.InventoryGroup] = W;
            else if ( (WeaponSlot[W.InventoryGroup] != PawnOwner.Weapon)
                    && ((W == PawnOwner.PendingWeapon) || (WeaponSlot[W.InventoryGroup].AutoSwitchPriority < W.AutoSwitchPriority)) )
                WeaponSlot[W.InventoryGroup] = W;
        }
        i++;
        if (i > 100)
            break; // can occasionally get temporary loops in netplay
    }
    W = PawnOwner.Weapon;

    // draw weapon list
    TexX = 128 * WeapScale;
    TexY = 64 * WeapScale;
    for (i=1; i<11; i++)
    {
        if (WeaponSlot[i] == None)
        {
            Canvas.Style = Style;
            Canvas.DrawColor =  0.5 * HUDColor;
            Canvas.CurX = BaseX + (i - 1) * WeaponOffset;
            Canvas.CurY = BaseY;
            
            WeapX = ((i-1)%4) * 64;
            WeapY = ((i-1)/4) * 32;
            Canvas.DrawTile(Texture'HUDWeaponsA',TexX,TexY,WeapX,WeapY,64.0,32.0);
        }
        else if (WeaponSlot[i] != W)
        {
            if (Pending == i)
            {
                if ((Opacity > 8) || !Level.bHighDetailMode)
                    Canvas.Style = ERenderStyle.STY_Normal;
                Canvas.DrawColor = SolidHUDColor;
            }
            else
            {
                Canvas.Style = Style;
                Canvas.DrawColor = 0.5 * HUDColor;
            }
            Canvas.CurX = BaseX + (i - 1) * WeaponOffset;
            Canvas.CurY = BaseY;
            
            if ( WeaponSlot[i].bSpecialIcon )
                Canvas.DrawIcon(WeaponSlot[i].StatusIcon, WeapScale);
            else
            {
                WeapX = ((i-1)%4) * 64;
                WeapY = ((i-1)/4) * 32;
                Canvas.DrawTile(Texture'HUDWeaponsA',TexX,TexY,WeapX,WeapY,64.0,32.0);
            }
        }
    }

    //draw weapon numbers and ammo
    TexX = 0.75 * WeapScale * 25;
    TexY = 0.75 * WeapScale * 64;
    for ( i=1; i<11; i++ )
    {
        if ( WeaponSlot[i] != None )
        {
            WeaponX = BaseX + (i - 1) * WeaponOffset + 4 * WeapScale;
            if ( WeaponSlot[i] != W )
            {
                Canvas.CurX = WeaponX;
                Canvas.CurY = BaseY + 4 * WeapScale;
                Canvas.DrawColor = GoldColor;
                if ((Opacity > 8) || !Level.bHighDetailMode)
                    Canvas.Style = ERenderStyle.STY_Normal;
                else
                    Canvas.Style = Style;
                if (i == 10)
                    Canvas.DrawTile(Texture'BotPack.HudElements1', TexX, TexY, 0, 0, 25.0, 64.0);
                else
                    Canvas.DrawTile(Texture'BotPack.HudElements1', TexX, TexY, 25*i, 0, 25.0, 64.0);
            }
            if (WeaponSlot[i].AmmoType != None)
            {
                // Draw Ammo bar
                Canvas.CurX = WeaponX;
                Canvas.CurY = BaseY + 52 * WeapScale;
                Canvas.DrawColor = BaseColor;
                AmmoScale = FClamp(88.0 * WeapScale * WeaponSlot[i].AmmoType.AmmoAmount/WeaponSlot[i].AmmoType.MaxAmmo, 0, 88);
                Canvas.DrawTile(Texture'BotPack.HudElements1', AmmoScale, 8 * WeapScale,64,64,128.0,8.0);
            }
        }
    }
}

defaultproperties
{
   bAlwaysRelevant=True
   bNetTemporary=True
}
