//
//base weapon class used mostly so they will be together in the actor tree
class FFWeapon extends TournamentWeapon abstract;

function ProcessTraceHitEffect(Actor Other, ConsumableAmmo consumable, Vector HitLocation, Vector HitNormal)
{
	if (!Level.bHighDetailMode)
		return;

	if (Level.bDropDetail)
		return;

	if (Other == Level) 
	{	
		if(consumable.spawnAtHitLoc != None) 
		{
			Spawn(consumable.spawnAtHitLoc,,, HitLocation+HitNormal, Rotator(HitNormal)).SetVelocity(HitNormal*50);
		}
		Spawn(class'FFWallHitEffect',,, HitLocation+HitNormal, Rotator(HitNormal));
		Spawn(consumable.splat,,, HitLocation+HitNormal, Rotator(HitNormal));
	}
}

simulated function PlayReloading()
{
	PlayAnim('Reload',0.5,0.05);
	Gotostate('Reloading');
}

state Reloading
{
	ignores Fire, AltFire;

Begin:
	FinishAnim();
	Finish();
}

event float BotDesireability(pawn Bot)
{
	//simple check so bots will not be attracted to thrown weapons
	if (bTossedOut)
      return -1;

   return Super.BotDesireability(Bot);
}

defaultproperties
{
}
