//
class FMCTFRulesClientWindow extends UTTeamRCWindow;

var UWindowCheckbox AnnounceCaptures, AllowAssists;
var localized string AnnounceText, AnnounceHelp, AssistText, AssistHelp;

function Created()
{
	local int ControlWidth, ControlLeft, ControlRight;
	
	ControlWidth = WinWidth / 2.5;
	ControlLeft = (WinWidth / 2 - ControlWidth) / 2;
	ControlRight = WinWidth / 2 + ControlLeft;
	
	Super.Created();
	
	Initialized = False;
	
	AnnounceCaptures = UWindowCheckbox(CreateControl(class'UWindowCheckbox', ControlLeft, ControlOffset, ControlWidth, 1));
	AnnounceCaptures.SetText(AnnounceText);
	AnnounceCaptures.SetHelpText(AnnounceHelp);
	AnnounceCaptures.SetFont(F_Normal);
	AnnounceCaptures.Align = TA_Right;
	AnnounceCaptures.bChecked = class<FlagMutatorCTFGame>(BotmatchParent.GameClass).default.bAnnounceCaptures;
	
	AllowAssists = UWindowCheckbox(CreateControl(class'UWindowCheckbox', ControlRight, ControlOffset, ControlWidth, 1));
	AllowAssists.SetText(AssistText);
	AllowAssists.SetHelpText(AssistHelp);
	AllowAssists.SetFont(F_Normal);
	AllowAssists.Align = TA_Right;
	AllowAssists.bChecked = class<FlagMutatorCTFGame>(BotmatchParent.GameClass).default.bAllowAssists;
	
	ControlOffset += 25;
	FFSlider.WinTop += 25;
	
	Initialized = True;
}

function BeforePaint(Canvas C, float X, float Y)
{
	local int ControlWidth, ControlLeft, ControlRight;
	
	Super.BeforePaint(C, X, Y);
	
	ControlWidth = WinWidth / 2.5;
	ControlLeft = (WinWidth / 2 - ControlWidth) / 2;
	ControlRight = WinWidth / 2 + ControlLeft;
	
	AnnounceCaptures.SetSize(ControlWidth, 1);
	AnnounceCaptures.WinLeft = ControlLeft;
	
	AllowAssists.SetSize(ControlWidth, 1);
	AllowAssists.WinLeft = ControlRight;
}

function Notify(UWindowDialogControl C, byte E)
{
	if ( !Initialized )
		return;
	
	Super.Notify(C, E);
	
	switch(E) 
	{
	case DE_Change:
		switch (C) 
		{
			case AnnounceCaptures:
				AnnounceChanged();
				break;
			case AllowAssists:
				AssistsChanged();
				break;
		}
	}
}

function AnnounceChanged()
{
	Class<FlagMutatorCTFGame>(BotmatchParent.GameClass).Default.bAnnounceCaptures = AnnounceCaptures.bChecked;
}

function AssistsChanged()
{
	Class<FlagMutatorCTFGame>(BotmatchParent.GameClass).Default.bAllowAssists = AllowAssists.bChecked;
}

defaultproperties
{
   AnnounceText="Announce Deliveries"
   AnnounceHelp="Burger deliveries get announced."
   AssistText="Enable Assists"
   AssistHelp="Every player who helped scores three extra points when the burger bomb is delivered."
}
