//
//all this code is wormbos
class FlagMutatorCTFGame extends CTFGame config;

#exec AUDIO IMPORT FILE="Sounds\assist.wav" 	NAME="Assist" 	GROUP="Announcer"
#exec AUDIO IMPORT FILE="Sounds\capture.wav" NAME="Capture" GROUP="Announcer"

var float LastAlertEmptyBase;
var string FakeGameName;
var config bool bAnnounceCaptures, bAllowAssists;
var class<SpawnNotify> FlagNotifyClass;

function PreBeginPlay()
{
	if (FlagNotifyClass != None)
		Spawn(FlagNotifyClass);
	GameName = FakeGameName;	// hack, so attack order is "Take their flag" not "Assault the base"
	Super.PreBeginPlay();
}

function Killed(pawn Killer, pawn Other, name damageType)
{
	local int NextTaunt, i;
	local bool bAutoTaunt;

	if (Other.bIsPlayer && Other.PlayerReplicationInfo.HasFlag != None)
	{
		MutatorFlagHolderDied(CTFFlag(Other.PlayerReplicationInfo.HasFlag), Other);
		
		if (Killer != None && Killer.bIsPlayer && Other.bIsPlayer && Killer.PlayerReplicationInfo.Team != Other.PlayerReplicationInfo.Team)
		{
			if (FlagMutatorFlag(Other.PlayerReplicationInfo.HasFlag) != None)
				FlagMutatorFlag(Other.PlayerReplicationInfo.HasFlag).AddAssistant(Killer);
			else
				log(Other.PlayerReplicationInfo.HasFlag@"is not a FlagMutatorFlag.");
			Killer.PlayerReplicationInfo.Score += 4;
			bAutoTaunt = TournamentPlayer(Killer) != None && TournamentPlayer(Killer).bAutoTaunt;
			if (Bot(Killer) != None || bAutoTaunt)
			{
				NextTaunt = Rand(class<ChallengeVoicePack>(Killer.PlayerReplicationInfo.VoiceType).Default.NumTaunts);
				for (i = 0; i < 4; i++) 
				{
					if (NextTaunt == LastTaunt[i])
						NextTaunt = Rand(class<ChallengeVoicePack>(Killer.PlayerReplicationInfo.VoiceType).Default.NumTaunts);
					if (i > 0)
						LastTaunt[i - 1] = LastTaunt[i];
				}	
				LastTaunt[3] = NextTaunt;
				Killer.SendGlobalMessage(None, 'AUTOTAUNT', NextTaunt, 5);
			}
		}
		if (FlagMutatorFlag(Other.PlayerReplicationInfo.HasFlag) != None)
			FlagMutatorFlag(Other.PlayerReplicationInfo.HasFlag).AddAssistant(Other);
		else
			log(Other.PlayerReplicationInfo.HasFlag@"is not a FlagMutatorFlag.");
		CTFFlag(Other.PlayerReplicationInfo.HasFlag).Drop(0.5 * Other.Velocity);
	}
	
	Super(TeamGamePlus).Killed(Killer, Other, damageType);
}

function ScoreFlag(Pawn Scorer, CTFFlag theFlag)
{
	local pawn TeamMate;
	local FlagMutatorFlag OtherFlag;
	local Actor A;
	local int i;

	if (Scorer.PlayerReplicationInfo.Team == theFlag.Team)
	{
		if (Level.Game.WorldLog != None)
			Level.Game.WorldLog.LogSpecialEvent("flag_returned", Scorer.PlayerReplicationInfo.PlayerID, Teams[theFlag.Team].TeamIndex);
		if (Level.Game.LocalLog != None)
			Level.Game.LocalLog.LogSpecialEvent("flag_returned", Scorer.PlayerReplicationInfo.PlayerID, Teams[theFlag.Team].TeamIndex);
		
		For (i = 0; i < 4; i++)
			if (i != theFlag.Team && FlagMutatorFlag(CTFReplicationInfo(GameReplicationInfo).FlagList[i]) != None && !CTFReplicationInfo(GameReplicationInfo).FlagList[i].bHome )
				FlagMutatorFlag(theFlag).AddAssistant(Scorer);
		BroadcastLocalizedMessage(class'CTFMessage', 1, Scorer.PlayerReplicationInfo, None, TheFlag);
		For (TeamMate = Level.PawnList; TeamMate != None; TeamMate = TeamMate.NextPawn)
		{
			if (TeamMate.IsA('PlayerPawn'))
				PlayerPawn(TeamMate).ClientPlaySound(ReturnSound);
			else if (TeamMate.IsA('Bot'))
				Bot(TeamMate).SetOrders(BotReplicationInfo(TeamMate.PlayerReplicationInfo).RealOrders, BotReplicationInfo(TeamMate.PlayerReplicationInfo).RealOrderGiver, true);
		}
		return;
	}
	
	if (bRatedGame && Scorer.IsA('PlayerPawn'))
		bFulfilledSpecial = true;
	Scorer.PlayerReplicationInfo.Score += 7;
	Teams[Scorer.PlayerReplicationInfo.Team].Score += 1.0;

	For (TeamMate = Level.PawnList; TeamMate != None; TeamMate = TeamMate.NextPawn)
	{
		if (TeamMate.IsA('PlayerPawn'))
			PlayerPawn(TeamMate).ClientPlaySound(CaptureSound[Scorer.PlayerReplicationInfo.Team]);
		else if (TeamMate.IsA('Bot'))
			Bot(TeamMate).SetOrders(BotReplicationInfo(TeamMate.PlayerReplicationInfo).RealOrders, BotReplicationInfo(TeamMate.PlayerReplicationInfo).RealOrderGiver, true);
	}

	if (FlagMutatorFlag(theFlag) != None)
	{
		if (bAllowAssists)
			FlagMutatorFlag(theFlag).ClearAssistance(Scorer.PlayerReplicationInfo.Team);
		else
			FlagMutatorFlag(theFlag).ClearAssistance(-1);
		for (i = 0; i < ArrayCount(FlagMutatorFlag(theFlag).AssistedBy); i++) 
		{
			TeamMate = FlagMutatorFlag(theFlag).AssistedBy[i];
			if (TeamMate == None)
				break;
			if (TeamMate != Scorer)
			{
				TeamMate.PlayerReplicationInfo.Score += 3;	// score points for assist
			}
		}
	}
	
	if (Level.Game.WorldLog != None)
		Level.Game.WorldLog.LogSpecialEvent("flag_captured", Scorer.PlayerReplicationInfo.PlayerID, Teams[theFlag.Team].TeamIndex);
	if (Level.Game.LocalLog != None)
		Level.Game.LocalLog.LogSpecialEvent("flag_captured", Scorer.PlayerReplicationInfo.PlayerID, Teams[theFlag.Team].TeamIndex);
	
	EndStatsClass.Default.TotalFlags++;
	BroadcastLocalizedMessage(class'CTFMessage', 0, Scorer.PlayerReplicationInfo, None, TheFlag);
	if (theFlag.HomeBase.Event != '')
		ForEach AllActors(class'Actor', A, theFlag.HomeBase.Event)
			A.Trigger(theFlag.HomeBase,	Scorer);

	if ((bOverTime || GoalTeamScore != 0) && Teams[Scorer.PlayerReplicationInfo.Team].Score >= GoalTeamScore)
		EndGame("teamscorelimit");
	else if ( bOverTime )
		EndGame("timelimit");
}

// fix 'Accessed None' with non-player pawns
function float GameThreatAdd(Bot aBot, Pawn Other)
{
	local CTFFlag aFlag;
	
	if (Other.bIsPlayer && Other.PlayerReplicationInfo.HasFlag != None)
		return 10;
	else
		return 0;
}

// fix 'Accessed None' with non-player pawns
function byte AssessBotAttitude(Bot aBot, Pawn Other)
{
	if (Other.IsA('StationaryPawn') && StationaryPawn(Other).SameTeamAs(aBot.PlayerReplicationInfo.Team))
		return 2;	// ignore my team's turret
	else if (Other.IsA('StationaryPawn'))
		return 0;	// fear other team's turret
	else if (!Other.bIsPlayer && (Other.Enemy == aBot || (Other.Enemy != None
			&& Other.Enemy.bIsPlayer && AssessBotAttitude(aBot, Other.Enemy) == 3)))
		return 1;	// he wants to attack me or my team mate
	else if (!Other.bIsPlayer )
		return 2;	// no interesting target
	else if (aBot.PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team)
		return 3;	//teammate
	else if (Other.PlayerReplicationInfo.HasFlag != None || aBot.PlayerReplicationInfo.HasFlag != None)
		return 1;
	else 
		return Super.AssessBotAttitude(aBot, Other);
}

function int GetPlayersAtHome(CTFFlag HomeFlag, float HomeSize, bool bFriends)
{
	local pawn P;
	local int Count;
	
	for (P = Level.PawnList; P != None; P = P.NextPawn)
		if (P.bIsPlayer && PlayerIsAtHome(HomeFlag, P, HomeSize))
		{
			if ((P.PlayerReplicationInfo.Team == HomeFlag.Team) == bFriends)
				Count++;
		}
	
	return Count;
}

function bool PlayerIsAtHome(CTFFlag HomeFlag, Pawn aPawn, float HomeSize)
{
	if (aPawn.Region.Zone == HomeFlag.HomeBase.Region.Zone || VSize(aPawn.Location - HomeFlag.HomeBase.Location) < HomeSize)
		return true;
	return false;
}

function bool IsOnTeam(Pawn Other, int TeamNum)
{
	if (Other.PlayerReplicationInfo != None && Other.PlayerReplicationInfo.Team == TeamNum)
		return true;
	else if (Other.IsA('StationaryPawn'))
		return StationaryPawn(Other).SameTeamAs(TeamNum);
	return false;
}

function bool FindSpecialAttractionFor(Bot aBot)
{
	local CTFFlag FriendlyFlag, EnemyFlag;
	local bool bSeeFlag, bReachHome, bOrdered;
	local float Dist, HomeSize;
	
	if (aBot.LastAttractCheck == Level.TimeSeconds)
		return false;
	aBot.LastAttractCheck = Level.TimeSeconds;

	FriendlyFlag = CTFReplicationInfo(GameReplicationInfo).FlagList[aBot.PlayerReplicationInfo.Team];
	
	if (aBot.PlayerReplicationInfo.Team == 0)
		EnemyFlag = CTFReplicationInfo(GameReplicationInfo).FlagList[1];
	else
		EnemyFlag = CTFReplicationInfo(GameReplicationInfo).FlagList[0];
	
	HomeSize = VSize(FriendlyFlag.HomeBase.Location - EnemyFlag.HomeBase.Location) / 4;
	
	bOrdered = aBot.bSniping || aBot.Orders == 'Follow' || aBot.Orders == 'Hold';

	if (!FriendlyFlag.bHome)
	{
		bSeeFlag = aBot.LineOfSightTo(FriendlyFlag.Position());
		FriendlyFlag.bKnownLocation = FriendlyFlag.bKnownLocation || bSeeFlag;
		
		if (bSeeFlag && FriendlyFlag.Holder == None && aBot.ActorReachable(FriendlyFlag))
		{
			if (Level.TimeSeconds - LastGotFlag > 6)
			{
				LastGotFlag = Level.TimeSeconds;
				aBot.SendTeamMessage(None, 'OTHER', 8, 20);	// "I've got our flag."
			}
			aBot.MoveTarget = FriendlyFlag;
			SetAttractionStateFor(aBot);
			return true;
		}
		
		if ( EnemyFlag.Holder != aBot ) 
		{
			if ( bSeeFlag && FriendlyFlag.Holder != None ) 
			{
				FriendlyFlag.bKnownLocation = true;
				if ( Level.TimeSeconds - LastSeeFlagCarrier > 6 ) 
				{
					LastSeeFlagCarrier = Level.TimeSeconds;
					aBot.SendTeamMessage(None, 'OTHER', 12, 10);	// "Enemy flag carrier is here."
				}
				aBot.SetEnemy(FriendlyFlag.Holder);
				aBot.Orders = 'Freelance';
				aBot.MoveTarget = FriendlyFlag.Holder;
				if ( aBot.IsInState('Attacking') )
					return false;
				else 
				{
					aBot.GotoState('Attacking');
					return true;
				}
			}
			else if (aBot.Orders == 'Attack')
			{
				// break off attack only if needed
				if (bSeeFlag || EnemyFlag.Holder != None
						|| ((FriendlyFlag.Position().Region.Zone != FriendlyFlag.Homebase.Region.Zone
						|| VSize(FriendlyFlag.Homebase.Location - FriendlyFlag.Position().Location) > 1000)
						&& (aBot.Region.Zone != EnemyFlag.Region.Zone
						|| VSize(aBot.Location - EnemyFlag.Location) > 1600
						|| VSize(aBot.Location - FriendlyFlag.Position().Location) < 1200)))
				{
					FriendlyFlag.bKnownLocation = true;
					aBot.MoveTarget = aBot.FindPathToward(FriendlyFlag.Position());
					aBot.AlternatePath = None;
					if (aBot.MoveTarget != None)
					{
						SetAttractionStateFor(aBot);
						return true;
					}
				}
			}
			else if ((!bOrdered || ABot.OrderObject.IsA('Bot')) && (FriendlyFlag.bKnownLocation
					|| FRand() < 0.1))
			{
				FriendlyFlag.bKnownLocation = true;
				aBot.MoveTarget = aBot.FindPathToward(FriendlyFlag.Position());
				if (aBot.MoveTarget != None)
				{
					SetAttractionStateFor(aBot);
					return true;
				}
			}
		}
	}
	else if (Level.TimeSeconds - LastAlertEmptyBase > 6
			&& VSize(aBot.Location - FriendlyFlag.HomeBase.Location) < HomeSize * 2
			&& GetPlayersAtHome(FriendlyFlag, HomeSize, False) > 0
			&& GetPlayersAtHome(FriendlyFlag, HomeSize * 1.5, True) == 0)
	{
		LastAlertEmptyBase = Level.TimeSeconds;
		aBot.SendTeamMessage(None, 'OTHER', 0, 10);	// "Base is uncovered!" - no team mate in own base
	}
	
	if (EnemyFlag.Holder == aBot)
	{
		aBot.bCanTranslocate = false;
		bReachHome = aBot.ActorReachable(FriendlyFlag.HomeBase);
		if (bReachHome && !FriendlyFlag.bHome)
		{
			aBot.SendTeamMessage(None, 'OTHER', 1, 25);	// "Somebody get our flag back."
			aBot.Orders = 'Freelance';
			return false;
		}
		if (bReachHome && VSize(aBot.Location - FriendlyFlag.Location) < 30)
			FriendlyFlag.Touch(aBot);
		if (aBot.Enemy != None)
		{
			if (aBot.Health < 60)
				aBot.SendTeamMessage(None, 'OTHER', 13, 25);	// "Need backup."
			if (!aBot.IsInState('FallBack'))
			{
				aBot.bNoClearSpecial = true;
				aBot.TweenToRunning(0.1);
				aBot.GotoState('Fallback', 'SpecialNavig');
			}
			if (bReachHome)
				aBot.MoveTarget = FriendlyFlag.HomeBase;
			else
				return FindPathToBase(aBot, FriendlyFlag.HomeBase);
		}
		else 
		{
			if (!aBot.IsInState('Roaming'))
			{
				aBot.bNoClearSpecial = true;
				aBot.TweenToRunning(0.1);
				aBot.GotoState('Roaming', 'SpecialNavig');
			}
			if (bReachHome)
				aBot.MoveTarget = FriendlyFlag.HomeBase;
			else
				return FindPathToBase(aBot, FriendlyFlag.HomeBase);
		}		
		return true;
	}
	
	if (EnemyFlag.Holder == None)
	{
		if (aBot.ActorReachable(EnemyFlag))
		{
			aBot.MoveTarget = EnemyFlag;
			SetAttractionStateFor(aBot);
			return true;
		}
		else if (aBot.Orders == 'Attack' || (aBot.Orders == 'Follow' && aBot.OrderObject.IsA('Bot')
				&& ((Pawn(aBot.OrderObject).Health <= 0 || (EnemyFlag.Region.Zone == aBot.Region.Zone
				&& VSize(EnemyFlag.Location - aBot.Location) < 2000)))) ) {
			if ( !aBot.bKamikaze && (aBot.Weapon == None || aBot.Weapon.AIRating < 0.4))
			{
				aBot.bKamikaze = FRand() < 0.1;
				return false;
			}
			
			if (aBot.Enemy != None && (aBot.Enemy.IsA('PlayerPawn') || (aBot.Enemy.IsA('Bot')
					&& Bot(aBot.Enemy).Orders == 'Attack')) && ((aBot.Enemy.Region.Zone == FriendlyFlag.HomeBase.Region.Zone
					&& EnemyFlag.HomeBase.Region.Zone != FriendlyFlag.HomeBase.Region.Zone) 
					|| VSize(aBot.Enemy.Location - FriendlyFlag.HomeBase.Location) < 0.6 * VSize(aBot.Location - EnemyFlag.HomeBase.Location)))
			{
				aBot.SendTeamMessage(None, 'OTHER', 14, 15);	//"Incoming!"
				aBot.Orders = 'Freelance';
				return false;
			}
			
			if (EnemyFlag.bHome)
				FindPathToBase(aBot, EnemyFlag.HomeBase);
			else
				aBot.MoveTarget = aBot.FindPathToward(EnemyFlag);
			if (aBot.MoveTarget != None)
			{
				SetAttractionStateFor(aBot);
				return true;
			}
			else 
			{
				if (aBot.bVerbose)
					log(aBot$" no path to flag");
				return false;
			}
		}
		return false;
	}
	
	if ((bOrdered && !aBot.OrderObject.IsA('Bot')) || aBot.Weapon == None || aBot.Weapon.AIRating < 0.4)
		return false;
	
	if (aBot.Enemy == None && aBot.Orders != 'Defend') 
	{
		Dist = VSize(aBot.Location - EnemyFlag.Holder.Location);
		if (Dist > 500 || VSize(EnemyFlag.Holder.Velocity) > 230 || !aBot.LineOfSightTo(EnemyFlag.Holder))
		{
			aBot.MoveTarget = aBot.FindPathToward(EnemyFlag.Holder);
			if (!aBot.IsInState('Roaming'))
			{
				aBot.bNoClearSpecial = true;
				aBot.TweenToRunning(0.1);
				aBot.GotoState('Roaming', 'SpecialNavig');
				return true;
			}
			return (aBot.MoveTarget != None);
		}
		else 
		{
			if (!aBot.bInitLifeMessage)
			{
				aBot.bInitLifeMessage = true;
				aBot.SendTeamMessage(EnemyFlag.Holder.PlayerReplicationInfo, 'OTHER', 3, 10);	// "I've got your back."
			}
			if (FRand() < 0.35)
				aBot.GotoState('Wandering');
			else 
			{
				aBot.CampTime = 1.0;
				aBot.bCampOnlyOnce = true;
				aBot.GotoState('Roaming', 'Camp');
			}
			return true;
		}
	}
	return false;
}		

// fix 'Accessed None' with non-player pawns
function int ReduceDamage(int Damage, name DamageType, pawn Victim, pawn InstigatedBy)
{
	if (InstigatedBy != None && InstigatedBy.bIsPlayer && Victim.IsA('Bot')
			&& Victim.PlayerReplicationInfo.Team != InstigatedBy.PlayerReplicationInfo.Team
			&& (Victim.health < 35 || Victim.PlayerReplicationInfo.HasFlag != None))
		Bot(Victim).SendTeamMessage(None, 'OTHER', 4, 15);
	else if (InstigatedBy != None && InstigatedBy.IsA('StationaryPawn') && Victim.IsA('Bot')
			&& !StationaryPawn(InstigatedBy).SameTeamAs(Victim.PlayerReplicationInfo.Team)
			&& (Victim.health < 35 || Victim.PlayerReplicationInfo.HasFlag != None))
		Bot(Victim).SendTeamMessage(None, 'OTHER', 4, 15);
	
	return Super(TeamGamePlus).ReduceDamage(Damage, DamageType, Victim, InstigatedBy);
}

// Flag mutator functions
function MutatorFlagInit(CTFFlag Flag,bool bChangeSkin,bool bIsNeutral)
{
	local Mutator M;
	
	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).InitFlag(Flag,bChangeSkin,bIsNeutral);
}

function MutatorFlagHasBase(CTFFlag Flag,Actor Base)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).FlagHasBase(Flag,Base);
}

function MutatorFlagBeginCarry(CTFFlag Flag,Pawn Carrier)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).BeginCarry(Flag,Carrier);
}

function MutatorFlagEndCarry(CTFFlag Flag,Pawn Carrier)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).EndCarry(Flag,Carrier);
}

function MutatorFlagHolderDied(CTFFlag Flag,Pawn Holder)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).HolderDied(Flag,Holder);
}

function MutatorFlagSteal(CTFFlag Flag,Pawn PickerUpper)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).StealFlag(Flag,PickerUpper);
}

function MutatorFlagPickup(CTFFlag Flag,Pawn PickerUpper)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).PickUpFlag(Flag,PickerUpper);
}

function MutatorFlagDrop(CTFFlag Flag,Pawn Dropper)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).DropFlag(Flag,Dropper);
}

function MutatorFlagCapture(CTFFlag Flag,Pawn Capturer,Actor CapturePlace)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).Capture(Flag,Capturer,CapturePlace);
}

function MutatorScoreCapture(Pawn Capturer,int FlagCount,Actor CapturePlace)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).ScoreCapture(Capturer,FlagCount,CapturePlace);
}

function MutatorFlagReturn(CTFFlag Flag,Pawn Returner)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).Return(Flag,Returner);
}

function MutatorFlagAutoReturn(CTFFlag Flag)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).AutoReturn(Flag);
}

function MutatorFlagDrawBadge(CTFFlag Flag,Canvas Canvas,int Direction,int X,int Y,ChallengeHUD HUD)
{
	local Mutator M;

	For (M = NextFlagMutator(None); M != None; M = NextFlagMutator(M))
		FlagMutator(M).DrawFlagBadge(Flag,Canvas,Direction,X,Y,HUD);
}

function Mutator NextFlagMutator(Mutator M)
{
	if (M == None)
		M = BaseMutator;
	else
		M = M.NextMutator;
	while (M != None) 
	{
		if (M.IsA('FlagMutator'))
			break;
		M = M.NextMutator;
	}
	return M;
}

defaultproperties
{
   FakeGameName="Capture the Flag"
   bAnnounceCaptures=True
   bAllowAssists=True
   FlagNotifyClass=Class'FlagMutatorNotify'
   ScoreBoardType=Class'TwoTeamsCTFScoreBoard'
   RulesMenuType="FoodFight.FMCTFRulesScrollClient"
   HUDType=Class'FlagMutatorCTFHUD'
   GameName="CTF for Flag Effects"
}
