//
//all this code is wormbos
class FlagMutatorFlag extends CTFFlag;

var Pawn AssistedBy[32], LastHolder;
var localized string FlagName;
var bool bInitialized;
var class<LocalMessage> FlagMessage;

function PostBeginPlay()
{
	Super.PostBeginPlay();
	FlagMutatorCTFGame(Level.Game).MutatorFlagInit(Self, True, False);
}

function SetHolderLighting()
{
	LightEffect = LE_NonIncidence;
	LightBrightness = 100;
	LightHue = LightHue;
	LightRadius = 6;
	LightSaturation = LightSaturation;
	LightType = LT_Steady;
}

function SendHome()
{
	local int i;
	local Pawn aPawn;

	LightType = LT_None;
	if (Holder != None)
	{
		Holder.AmbientGlow = Holder.Default.AmbientGlow;
		Holder.PlayerReplicationInfo.HasFlag = None;
		if (Holder.FindInventoryType(class'Botpack.UDamage') == None)
			Holder.LightType = LT_None;
		if (Holder.Inventory != None)
			Holder.Inventory.SetOwnerDisplay();
		Holder = None;
	}
	GotoState('Home');
	SetPhysics(PHYS_None);
	bCollideWorld = false;
	SetLocation(HomeBase.Location);
	SetRotation(HomeBase.Rotation);
	SetBase(None);
	SetCollision(true, false, false);
	For (aPawn = Level.PawnList; aPawn != None; aPawn = aPawn.nextPawn)
		if (aPawn.MoveTarget == Self)
			aPawn.MoveTimer = -1.0;
	for (i = 0; i < ArrayCount(AssistedBy); i++)
		AssistedBy[i] = None;
}

function Drop(vector newVel)
{
	local vector X,Y,Z;
	local bool bHolderPainZone;
	
	BroadcastLocalizedMessage(FlagMessage, 2, Holder.PlayerReplicationInfo, None, CTFGame(Level.Game).Teams[Team]);
	if (Level.Game.WorldLog != None)
		Level.Game.WorldLog.LogSpecialEvent("flag_dropped", Holder.PlayerReplicationInfo.PlayerID, CTFGame(Level.Game).Teams[Team].TeamIndex);
	if (Level.Game.LocalLog != None)
		Level.Game.LocalLog.LogSpecialEvent("flag_dropped", Holder.PlayerReplicationInfo.PlayerID, CTFGame(Level.Game).Teams[Team].TeamIndex);
	
	RotationRate.Yaw = Rand(200000) - 100000;
	RotationRate.Pitch = Rand(200000 - Abs(RotationRate.Yaw)) - 0.5 * (200000 - Abs(RotationRate.Yaw));
	Velocity = (0.2 + FRand()) * (newVel + 400 * FRand() * VRand());
	If (Region.Zone.bWaterZone)
		Velocity *= 0.5;
	LastHolder = Holder;
	Holder.PlayerReplicationInfo.HasFlag = None;
	if (Holder.FindInventoryType(class'Botpack.UDamage') == None)
		Holder.LightType = LT_None;
	bHolderPainZone = Holder.Region.Zone.bPainZone && Holder.Region.Zone.DamagePerSec > 0;
	bHolderPainZone = bHolderPainZone || (Holder.FootRegion.Zone.bPainZone && (Holder.FootRegion.Zone.DamagePerSec > 0));
	if ( Holder.Inventory != None )
		Holder.Inventory.SetOwnerDisplay();
	Holder.Fatness = Default.fatness;
	Holder = None;
	GetAxes(LastHolder.Rotation, X, Y, Z);
	SetRotation(rotator(-1 * X));
	bCollideWorld = true;
	SetCollisionSize(0.5 * Default.CollisionRadius, CollisionHeight);
 	if (!SetLocation(LastHolder.Location - 2 * LastHolder.CollisionRadius * X + LastHolder.CollisionHeight * vect(0,0,0.5)) && !SetLocation(LastHolder.Location))
	{
		SetCollisionSize(0.8 * LastHolder.CollisionRadius, FMin(CollisionHeight, 0.8 * LastHolder.CollisionHeight));
		if (!SetLocation(LastHolder.Location))
		{
			SendHome();
			return;
		}
	}
	
	SetPhysics(PHYS_Falling);
	SetBase(None);
	SetCollision(true, false, false);
	GotoState('Dropped');
	if (bHolderPainZone)
		Timer();
}

function Tick(float DeltaTime)
{
	if (!bInitialized && HomeBase != None)
	{
		FlagMutatorCTFGame(Level.Game).MutatorFlagHasBase(Self, HomeBase);
		bInitialized = true;
	}
	Super.Tick(DeltaTime);
}

function AddAssistant(pawn Assistant)
{
	local int i;
	
	if (Assistant == None)
		return;
	for (i = 0; i < ArrayCount(AssistedBy); i++)
		if (Assistant == AssistedBy[i])
			return;
	
	for (i = ArrayCount(AssistedBy) - 1; i > 0; i--)
		AssistedBy[i] = AssistedBy[i - 1];
	AssistedBy[0] = Assistant;
}

function ClearAssistance(int Team)
{
	local int i, j;
	
	for (i = 0; i < ArrayCount(AssistedBy); i++) 
	{
		if (AssistedBy[i] == None)
			return;
		if (AssistedBy[i].PlayerReplicationInfo.Team != Team)
		{
			AssistedBy[31] = None;
			for (j = i; j < ArrayCount(AssistedBy) - 1; j++)
				AssistedBy[j] = AssistedBy[j + 1];
		}
	}
}

function string GetHumanName()
{
	return FlagName;
}

state Held
{
	function BeginState()
	{
		Super.BeginState();
		FlagMutatorCTFGame(Level.Game).MutatorFlagBeginCarry(Self, Holder);
	}
	
	function Tick(float DeltaTime)
	{
		Super.Tick(DeltaTime);
		if (Holder != None)
		{
			SetLocation(Holder.Location);
			Velocity = Holder.Velocity;
		}
	}
	
	function EndState()
	{
		FlagMutatorCTFGame(Level.Game).MutatorFlagEndCarry(Self, LastHolder);
		Super.EndState();
	}
}		

state Dropped
{
	function Timer()
	{
		FlagMutatorCTFGame(Level.Game).MutatorFlagAutoReturn(Self);
		Super.Timer();
	}
	
	function Touch(Actor Other)
	{
		local CTFFlag aFlag;
		local Pawn aPawn;
		local NavigationPoint N;
		local int num, i;
		
		aPawn = Pawn(Other);
		if (aPawn != None && aPawn.bIsPlayer && aPawn.Health > 0 && !aPawn.IsInState('FeigningDeath'))
		{
			aPawn.MoveTimer = -1;
			if (aPawn.PlayerReplicationInfo.Team == Team)
			{
				// returned flag
				CTFGame(Level.Game).ScoreFlag(aPawn, Self);
				FlagMutatorCTFGame(Level.Game).MutatorFlagReturn(Self, aPawn);
				SendHome();
				return;
			}
			else 
			{
				Holder = aPawn;
				Holder.PlayerReplicationInfo.HasFlag = Self;
				SetHolderLighting();
				if (Holder.IsA('Bot'))
				{
					Bot(Holder).AlternatePath = None;
					Holder.SendTeamMessage(None, 'OTHER', 2, 10);
				}
				else if (Holder.IsA('TournamentPlayer') && TournamentPlayer(Holder).bAutoTaunt)
					Holder.SendTeamMessage(None, 'OTHER', 2, 10);
			}
			BroadcastLocalizedMessage(class'CTFMessage', 4, Holder.PlayerReplicationInfo, None, CTFGame(Level.Game).Teams[Team]);
			if (Level.Game.WorldLog != None)
				Level.Game.WorldLog.LogSpecialEvent("flag_pickedup", Holder.PlayerReplicationInfo.PlayerID, CTFGame(Level.Game).Teams[Team].TeamIndex);
			if (Level.Game.LocalLog != None)
				Level.Game.LocalLog.LogSpecialEvent("flag_pickedup", Holder.PlayerReplicationInfo.PlayerID, CTFGame(Level.Game).Teams[Team].TeamIndex);
			GotoState('Held');
			FlagMutatorCTFGame(Level.Game).MutatorFlagPickup(Self, Holder);
		}
	}

	function BeginState()
	{
		FlagMutatorCTFGame(Level.Game).MutatorFlagDrop(Self, LastHolder);
		Super.BeginState();
	}
}

auto state Home
{
	function Touch(Actor Other)
	{
		local CTFFlag aFlag;
		local Pawn aPawn;
		local NavigationPoint N;
		local int i;
		local float totalweight, selection, PartialWeight;
		local Bot B;

		aPawn = Pawn(Other);
		if (aPawn != None && aPawn.bIsPlayer && aPawn.Health > 0)
		{
			// check if scored capture
			if (aPawn.PlayerReplicationInfo.Team == Team)
			{
				if (aPawn.PlayerReplicationInfo.HasFlag != None)
				{
					//Score!
					aFlag = CTFFlag(aPawn.PlayerReplicationInfo.HasFlag);
					FlagMutatorCTFGame(Level.Game).MutatorFlagCapture(aFlag, aPawn, HomeBase);
					CTFGame(Level.Game).ScoreFlag(aPawn, aFlag);
					FlagMutatorCTFGame(Level.Game).MutatorScoreCapture(aPawn, 1, HomeBase);
					aFlag.SendHome();
				}
			}
			else 
			{
				Holder = aPawn;
				Holder.MoveTimer = -1;
				Holder.PlayerReplicationInfo.HasFlag = Self;
				Holder.MakeNoise(2.0);
				SetHolderLighting();
				FlagMutatorCTFGame(Level.Game).MutatorFlagSteal(Self, Holder);
				B = Bot(Holder);
				if (B != None) 
				{
					B.AlternatePath = None;
					if (FRand() < 0.5)
					{
						For (N = Level.NavigationPointList; N != None; N = N.nextNavigationPoint)
							if (N.IsA('AlternatePath') && (AlternatePath(N).bTwoWay || AlternatePath(N).Team == Holder.PlayerReplicationInfo.Team))
							{
								if (AlternatePath(N).bTwoWay && (AlternatePath(N).team != Holder.PlayerReplicationInfo.team))
									TotalWeight += 4000;
								TotalWeight += AlternatePath(N).SelectionWeight;
							}
						selection = TotalWeight * FRand();
						For (N = Level.NavigationPointList; N != None; N = N.nextNavigationPoint)
							if (N.IsA('AlternatePath') && (AlternatePath(N).bTwoWay || AlternatePath(N).Team == Holder.PlayerReplicationInfo.Team))
							{
								B.AlternatePath = AlternatePath(N);
								if (AlternatePath(N).bTwoWay && (AlternatePath(N).Team != Holder.PlayerReplicationInfo.Team))
									PartialWeight += 4000;
								PartialWeight += AlternatePath(N).SelectionWeight;
								if (PartialWeight > selection)
									break;
							}
					}
					B.SendTeamMessage(None, 'OTHER', 2, 10);
				}
				else if (Holder.IsA('TournamentPlayer') && TournamentPlayer(Holder).bAutoTaunt)
					Holder.SendTeamMessage(None, 'OTHER', 2, 10);

				if (Level.Game.WorldLog != None)
					Level.Game.WorldLog.LogSpecialEvent("flag_taken", Holder.PlayerReplicationInfo.PlayerID, CTFGame(Level.Game).Teams[Team].TeamIndex);
				if (Level.Game.LocalLog != None)
					Level.Game.LocalLog.LogSpecialEvent("flag_taken", Holder.PlayerReplicationInfo.PlayerID, CTFGame(Level.Game).Teams[Team].TeamIndex);
				BroadcastLocalizedMessage(class'CTFMessage', 6, Holder.PlayerReplicationInfo, None, CTFGame(Level.Game).Teams[Team]);
				GotoState('Held');
			}
		}
	}
}

defaultproperties
{
   FlagName="Blue Flag"
   Skin=Texture'JpflagBA'
   Multiskins(0)=Texture'JpflagBA'
   FlagMessage=Class'Botpack.CTFMessage'
}
