//
//this is the tossed JellyJumper. It flies out until it hits the ground
//then updates it's rotation and places a proper jump pad.
class JellyJumperPadFlying extends Projectile;

var bool bCanHitOwner, bHitWater, Detonating;
var float Count, SmokeRate;
var int NumExtraGrenades;
var Paprinade nextNade;
var() bool CanHitInstigator;
var() float HitInstigatorTimeOut;

Replication
{
   UnReliable if (Role == ROLE_Authority)
      Detonating;
}

simulated function PostBeginPlay()
{
	local vector X,Y,Z;
	local rotator RandRot;

	Super.PostBeginPlay();
	if (Level.NetMode != NM_DedicatedServer)
		PlayAnim('Still');
	SetTimer(3+FRand()*0.5,false);
	Detonating= False;

	if (Role == ROLE_Authority)
	{
		GetAxes(Instigator.ViewRotation,X,Y,Z);	
		Velocity = X * (Instigator.Velocity Dot X)*0.4 + Vector(Rotation) * (Speed + FRand() * 100);
		Velocity.z += 310;  //Tossforce
		MaxSpeed = 1000;
		bCanHitOwner = False;
		if (Instigator.HeadRegion.Zone.bWaterZone)
		{
			bHitWater = True;
			Disable('Tick');
			Velocity=0.6*Velocity;			
		}
	}
}

simulated function ZoneChange(Zoneinfo NewZone)
{
	local waterring w;
	
	if (!NewZone.bWaterZone || bHitWater) Return;
	bHitWater = True;
	w = Spawn(class'WaterRing',,,,rot(16384,0,0));
	w.DrawScale = 0.2;
	w.RemoteRole = ROLE_None;
	Velocity=0.1*Velocity;
}

function Timer()
{
	if (Detonating == False)
	{
		Detonating = True;
		Explosion(Location+Vect(0,0,1)*16);
	}
}

simulated function Landed(vector HitNormal)
{
	HitWall(HitNormal, None);
}

simulated function ProcessTouch(actor Other, vector HitLocation)
{
	if ((!CanHitInstigator || (CanHitInstigator && (Default.LifeSpan - LifeSpan) < HitInstigatorTimeOut)) && Other == Instigator)
		return;

	if ((Other!=instigator) || bCanHitOwner)
		Explosion(HitLocation);
}

simulated function HitWall(vector HitNormal, actor Wall)
{
	bCanHitOwner = True;
	Velocity = 0.3*(( Velocity dot HitNormal ) * HitNormal * (-2.0) + Velocity);   // Reflect off Wall w/damping
	speed = VSize(Velocity);
	if (Level.NetMode != NM_DedicatedServer)
		PlaySound(ImpactSound, SLOT_Misc, 1.5 );
	if (Velocity.Z > 400)
		Velocity.Z = 0.5 * (400 + Velocity.Z);	
	else if (speed < 20)
	{
		bBounce = False;
		SetPhysics(PHYS_None);
	}
}

function Explosion(vector HitLocation)
{
	local JellyJumperPad b;

	b = Spawn(class'JellyJumperPad',,,HitLocation,rot(0,0,0));
	if (b.Physics == PHYS_None) 
		b.SetPhysics(PHYS_Falling);
	Spawn(class'UT_SpriteSmokePuff',,,HitLocation);
	Destroy();
}

defaultproperties
{
	HitInstigatorTimeOut=0.500000
	CanHitInstigator=True
   speed=600.000000
   MaxSpeed=1000.000000
	Damage=0.00
	MomentumTransfer=0.00
   MyDamageType=GrenadeDeath
   ImpactSound=Sound'JellyB'
   ExplosionDecal=Class'FFBlastMark'
	Physics=PHYS_Falling
	RemoteRole=ROLE_SimulatedProxy
	AnimSequence=Bounce
	Mesh=JellyJumpPlatformPickup
   AmbientGlow=64
   bUnlit=True
   bBounce=True
   bFixedRotationDir=True
   CollisionHeight=10.000000
   bNetTemporary=False
}
