//
//health vial replacement
class JuiceBottleOrange extends TournamentHealth;

#exec MESH IMPORT MESH=JuiceBottle ANIVFILE=MODELS\JuiceBottle_a.3d DATAFILE=MODELS\JuiceBottle_d.3d X=0 Y=0 Z=0 UnMirror=1
#exec MESH ORIGIN MESH=JuiceBottle X=0 Y=0 Z=235
#exec MESH SEQUENCE MESH=JuiceBottle SEQ=All STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW MESHMAP=JuiceBottle MESH=JuiceBottle
#exec MESHMAP SCALE MESHMAP=JuiceBottle X=0.05 Y=0.05 Z=0.1
#exec MESH LODPARAMS MESH=JuiceBottle STRENGTH=0

#exec TEXTURE IMPORT NAME=Orangebottle FILE=Textures\Orangebottle.BMP GROUP=Skins
#exec MESHMAP SETTEXTURE MESHMAP=JuiceBottle NUM=1 TEXTURE=Orangebottle
#exec MESHMAP SETTEXTURE MESHMAP=JuiceBottle NUM=2 TEXTURE=Orangebottle

auto state Pickup
{
	function Touch(actor Other)
   {
   	local int HealMax;
      local Pawn P;
            
      if (ValidTouch(Other))
      {
      	P = Pawn(Other);
         HealMax = P.default.health;
         if (bSuperHeal) HealMax = Min(199, HealMax * 2.0);
         if (P.Health < HealMax)
         {
            P.Health += HealingAmount;
            if (P.Health > HealMax) P.Health = HealMax;
            PlayPickupMessage(P);
            PlaySound (PickupSound,,2.5);
            Other.MakeNoise(0.2);
            LightBrightness = 0;
      		LightRadius = 0;
      		LightEffect=LE_SlowWave;
      		LightHue=0;
      		LightSaturation=0;
            SetRespawn();
         }
      }
   }

   function BeginState()
   {
      Super.BeginState();
      NumCopies = 0;
      LightBrightness = 100;
      LightRadius = 8;
      LightEffect=LE_SlowWave;
      LightHue=50;
      LightSaturation=0;
   }
}

defaultproperties
{
   PickupSound=sound'Botpack.Pickups.UTHealth'
   bUnlit=True
   bSuperHeal=true
   bRotatingPickup=True
   HealingAmount=5
   RespawnTime=30.000000
   CollisionRadius=10.000000
   CollisionHeight=22.000000
   PickupMessage="You picked up an Orange Juice Bottle +"
   PickupViewMesh=JuiceBottle
   PickupViewScale=1.000000
   Mesh=JuiceBottle
   DrawScale=0.750000
   ScaleGlow=2.000000
   ItemName="OrangeJuiceBottle"
   LightType=LT_Steady
   RemoteRole=ROLE_SimulatedProxy
}
