//
class NeutralFlagBase extends FlagBase;

function PostBeginPlay()
{
	local NeutralFlag myFlag;

	Super(NavigationPoint).PostBeginPlay();
	if (!Level.Game.IsA('BurgerCTFGame'))
		return;

	bHidden = false;
	myFlag = Spawn(class'NeutralFlag');
	myFlag.HomeBase = Self;
	BurgerReplicationInfo(Level.Game.GameReplicationInfo).NeutralFlag = myFlag;
	BurgerCTFGame(Level.Game).MutatorFlagHasBase(myFlag, Self);
	myFlag.bInitialized = True;
}

simulated function Tick(float DeltaTime)
{
	local BlackSmoke b;
	local SmallSpark2 c;

	if (Level.bDropDetail)
	{
		Disable('Tick');
		Return;
	}
	if (FRand()<0.05)
	{
		b = Spawn(class'BlackSmoke');
		b.RemoteRole = ROLE_None;
		c = Spawn(class'SmallSpark2');
		c.RemoteRole = ROLE_None;
	}
}

function Destroyed()
{
	log("A burger base was destroyed ("$Self$")");
	Super.Destroyed();
}

defaultproperties
{
   Team=3
   bNoDelete=False
   AmbientGlow=128
	Mesh=LodMesh'Burger'
   DrawScale=0.400000
}
