//
//Non damaging flames, strictly visual effect for the red globs
class ObjectsFlamesB expands Actor;

simulated function PostBeginPlay()
{
	local int i;

	if (Region.Zone.bWaterZone) //Flames cannot exist underwater
		Destroy();

	if (Owner != None)
	{
		if(Owner.Fatness != Default.fatness)
			Destroy();
			
		if (Owner.IsA('Pawn') || Owner.IsA('Carcass'))
			AmbientSound = Sound'PawnBurn';
		else
		{
			AmbientSound = Sound'OtherBurn';
			SoundVolume *= 2;
		}
	}
	SetTimer(0.2,True);
}

simulated function Timer()
{
	local RisingFlames F;
	local Actor A;
	local bool bOwnedSome;

	if (Owner != None)
	{
		ForEach VisibleCollidingActors (Class'Actor', A, 32, Owner.Location)
		{
			if (A == Owner)
				bOwnedSome = True;
		}
	}

	If (Owner == None || !bOwnedSome)
	{
		Destroy();
		return;
	}
	else if (Owner.bHidden)
	{
		Destroy();
		return;
	}

	if (Level.NetMode != NM_DedicatedServer)
	{
		F = Spawn(Class'RisingFlames', Owner,, Owner.Location, Owner.Rotation);
		F.Mesh = Owner.Mesh;
		F.AnimSequence = Owner.AnimSequence;
		F.AnimFrame = Owner.AnimFrame;
	}

	If (Region.Zone.bWaterZone)
	{
		PlaySound(Sound'PosFireSteam',,10.0,,2200);
		Destroy();
	}
}

defaultproperties
{
   bHidden=True
   Physics=PHYS_Trailer
   RemoteRole=Role_SimulatedProxy
   LifeSpan=8.00
   SoundVolume=96
   LightType=LT_Steady
   LightEffect=LE_NonIncidence
   LightBrightness=100
   LightRadius=8
}
