//
//effects on the player, the visual part is handled in the HUD class
class PepperEffect extends Pickup;

#exec AUDIO IMPORT NAME="sneeze1" FILE=Sounds\sneeze1.wav
#exec AUDIO IMPORT NAME="sneeze2" FILE=Sounds\sneeze2.wav
#exec AUDIO IMPORT NAME="sneeze3" FILE=Sounds\sneeze3.wav

var() float Duration;
var() float ElapsedTime;
var() bool bPepperActive;
var() Pawn Instigator;
var() Vector Hitlocation;
var() Vector Momentum;
var float Offset;
var sound sneezes[3];
var float DefaultFOV, CurrentFOV, TargetFOV;
var float BotAcc;
var Pawn P;

replication
{
   reliable if( Role==ROLE_Authority )
      bPepperActive;
}

singular function UsedUp()
{
   bPepperActive = False;
   if (Owner.Isa('PlayerPawn'))
	{
      PlayerPawn(Owner).SetFOVAngle(DefaultFOV);
   } else if (Owner.Isa('Bot')) 
	{
      Bot(Owner).Accuracy = BotAcc;
   }
   Pawn(Owner).GroundSpeed=Pawn(Owner).Default.GroundSpeed;
   SetTimer(0.0, False);
  Destroy();
}

function Destroyed()
{
   bPepperActive = False;

   if (Owner.Isa('PlayerPawn'))
   {
      PlayerPawn(Owner).SetFOVAngle(DefaultFOV);
   } 
	else if (Owner.Isa('Bot'))
   {
      Bot(Owner).Accuracy = BotAcc;
   }
   Pawn(Owner).GroundSpeed=Pawn(Owner).Default.GroundSpeed;
   SetTimer(0.0, False);
   Super.Destroyed();
}

state Activated
{
   function Tick(float deltaTime)
   {
      If ((Owner == None) || (Pawn(Owner).Health < 0))
      {
         log("Owner died, undoing pepper");
         UsedUp();
      }

      if (Owner.Isa('PlayerPawn'))
      {
         if (CurrentFOV != TargetFOV)
         {
            CurrentFOV=CurrentFOV + Offset;
            PlayerPawn(Owner).SetFOVAngle(CurrentFOV);
         }
         else
         {
            if (TargetFOV==75.0)
            {
               TargetFOV=105.0;   
               Offset = 0.5;
            }
            else
            {
               TargetFOV=75.0;
               Offset=-0.5;
            }
         }
      }
   }

   function Timer()
   {
   	local int r;

      if (ElapsedTime > Duration)
      {
         bPepperActive = False;
         UsedUp();      
      }
      else
      {
         ElapsedTime+=1;
         if (Instigator == None)
         {
            Instigator=Pawn(Owner);
            Hitlocation = Owner.Location;
            Momentum=Vect(0,0,0);
         }
         R=Rand(20);
         if (R < 6)
            Sneezing();
         if (PlayerPawn(Owner) != None)
            PlayerPawn(Owner).ShakeView(1.5, 1000.0, 500.0);
      }
   }

Begin:
   P=Pawn(Owner);
   if (P != None)
   {
      bPepperActive = True;
      ElapsedTime=0;
      if (Owner.Isa('PlayerPawn'))
      {
         PlayerPawn(Owner).DesiredFOV = PlayerPawn(Owner).DefaultFOV;
         DefaultFOV=90; //PlayerPawn(Owner).FOVAngle;
         CurrentFOV=90; //PlayerPawn(Owner).FOVAngle;
         TargetFOV=75;
         Offset=-0.5;
      }
      else if (Owner.Isa('Bot'))
      {
      	BotAcc = Bot(Owner).Accuracy;
         Bot(Owner).Accuracy = -2.0;
      }
      Enable('Tick');
      SetTimer(1.0, True);
      Pawn(Owner).GroundSpeed=Pawn(Owner).GroundSpeed*0.90;
   }
   else
      Super.Destroyed();
}

function Sneezing()
{
   local int Numbubbles, i;
   local vector realLoc;
   local Vector Start, X,Y,Z;
   local actor s;

   Owner.PlaySound(sneezes[Rand(3)],Slot_Talk,200,,500);
   NumBubbles=Rand(3);
   for(i=0;i<Numbubbles;i++)
   {
      GetAxes(Pawn(Owner).ViewRotation,X,Y,Z);
      realLoc = Owner.Location + CalcDrawOffset();
      s = Spawn(class'SpriteSmokePuff',, '', realLoc + 50 * X + Y + (Z*10));
   }
}

defaultproperties
{
   duration=10.00
   sneezes(0)=Sound'sneeze1'
   sneezes(1)=Sound'sneeze2'
   sneezes(2)=Sound'sneeze3'
   bAutoActivate=True
   bActivatable=True
   PickupMessage=""
   PickupViewMesh=LodMesh'Peppermill'
   M_Activated=""
   M_Deactivated=""
   Mesh=LodMesh'Peppermill'
}
