//
//the victim effect is handled in the HUD class
class PepperMill extends TournamentPickup;

#exec MESH IMPORT MESH=Peppermill ANIVFILE=MODELS\Peppermill_a.3d DATAFILE=MODELS\Peppermill_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=Peppermill X=0 Y=0 Z=0
#exec MESH LODPARAMS MESH=Peppermill STRENGTH=0
#exec MESH SEQUENCE MESH=Peppermill SEQ=All STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW MESHMAP=Peppermill MESH=Peppermill
#exec MESHMAP SCALE MESHMAP=Peppermill X=0.05 Y=0.05 Z=0.1

#exec TEXTURE IMPORT NAME=peppermillskin 	FILE=Textures/peppermillskin.bmp GROUP="Skins"
#exec TEXTURE IMPORT NAME=pepperglass 		FILE=Textures/pepperglass.bmp 	GROUP="Skins"

#exec MESHMAP SETTEXTURE MESHMAP=Peppermill NUM=0 TEXTURE=peppermillskin
#exec MESHMAP SETTEXTURE MESHMAP=Peppermill NUM=1 TEXTURE=pepperglass
#exec MESHMAP SETTEXTURE MESHMAP=Peppermill NUM=2 TEXTURE=peppermillskin
#exec MESHMAP SETTEXTURE MESHMAP=Peppermill NUM=3 TEXTURE=peppermillskin
#exec MESHMAP SETTEXTURE MESHMAP=Peppermill NUM=4 TEXTURE=peppermillskin
#exec MESHMAP SETTEXTURE MESHMAP=Peppermill NUM=5 TEXTURE=peppermillskin
#exec MESHMAP SETTEXTURE MESHMAP=Peppermill NUM=6 TEXTURE=peppermillskin

var PepperSkinEffect MyEffect;

function ArmorImpactEffect(vector HitLocation)
{ 
   if (Owner.IsA('PlayerPawn'))
   {
      PlayerPawn(Owner).ClientFlash(-0.05,vect(400,400,400));
      PlayerPawn(Owner).PlaySound(DeActivateSound, SLOT_None, 2.7*PlayerPawn(Owner).SoundDampening);
   }
   if (MyEffect != None)
   {
      MyEffect.ScaleGlow = 4.0;
      MyEffect.Fatness = 255;
      SetTimer(0.8, false);
   }
}

function Timer()
{
   if (MyEffect != None)
   {
      MyEffect.Fatness = MyEffect.Default.Fatness;
   }
}

function Destroyed()
{
   if (Owner != None)
   {
      Owner.SetDefaultDisplayProperties();
      if(Owner.Inventory != None)
         Owner.Inventory.SetOwnerDisplay();
   }
   if (MyEffect != None)
      MyEffect.Destroy();
   Super.Destroyed();
}

//sets the player's skin so others know he is powered up
function PickupFunction(Pawn Other)
{
   local Inventory I;

   MyEffect = Spawn(class'PepperSkinEffect', Other,,Other.Location, Other.Rotation);
   MyEffect.Mesh = Owner.Mesh;
   MyEffect.DrawScale = Owner.Drawscale;
   MyEffect.ScaleGlow = 1.0;
   MyEffect.ScaleGlow *= (0.25 + 0.75 * Charge/Default.Charge);
	MyEffect.Texture = Texture'watereffect1';

   // remove other armors
   for (I=Owner.Inventory; I!=None; I=I.Inventory)
      if (I.bIsAnArmor && (I != self))
         I.Destroy();
}

state Activated
{
   function endstate()
   {
      local Inventory S;

      bActive = false;
      PlaySound(DeActivateSound);
      Owner.SetDefaultDisplayProperties();
      S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
      if ((S != None) && (UT_Shieldbelt(S).MyEffect != None))
         UT_Shieldbelt(S).MyEffect.bHidden = false;
   }

   function Activate()
   {
      bActive = true;
      SetOwnerDisplay();
   }

   function SetOwnerDisplay()
   {
      if (!bActive)
         return;
   }

   function ChangedWeapon()
   {
      if (!bActive)
         return;
      if(Inventory != None)
         Inventory.ChangedWeapon();
   }

   function Timer()
   {
      Charge -= 1;
      RRgib();
      Pawn(Owner).Visibility = 10;
      Owner.AmbientGlow = 250;
		Owner.LightEffect=LE_Rotor;
		Owner.LightBrightness=64;
		Owner.LightHue=80;
		Owner.LightRadius=32;
		Owner.LightSaturation=240;
		Owner.LightType=LT_Steady;

      if (Charge<-0)
      {
			Owner.AmbientGlow = Owner.Default.AmbientGlow;
			Owner.LightType = LT_None;
			Pawn(Owner).DamageScaling = 1.0;
			UsedUp();
		}
		//almost used up, let's warn the owner
		if (Charge < 12 && Charge > 0)
			Owner.PlaySound(Sound'BotPack.ChatSound.NewBeep');
   }

   function BeginState()
   {
      local Inventory S;

      bActive = true;
      PlaySound(ActivateSound,,4.0);
      SetTimer(0.5,True);
      S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
      if ((S != None) && (UT_Shieldbelt(S).MyEffect != None))
         UT_Shieldbelt(S).MyEffect.bHidden = true;
   }
}

state DeActivated
{
Begin:
}

//this function searches for pawns close enough to the pickup's owner. if it finds someone
//and there is clean line-of-sight then it spawns a pepper effect on them
function RRgib()
{
   local vector Start, HitLocation, X;
   local PlayerPawn P;
   local Bot B;
   local Vector EndFlashFog;
	local float f;
	local PepperEffect PE;

   EndFlashFog.X=60;
	EndFlashFog.Y=1;	
	EndFlashFog.Z=0;

   Start = Pawn(Owner).Location;

   foreach VisibleActors(class'PlayerPawn', P, 350, Start)
	{
		if ((P != self) && (P != None) && (P.PlayerReplicationInfo.Team != Pawn(Owner).PlayerReplicationInfo.Team))
		{
			if ((P.Health > 0) && (P.FindInventoryType(class'PepperEffect') == None))
			{
      		P.ClientFlash( 2, 1000*EndFlashFog );
      		PE = PepperEffect(P.FindInventoryType(class'PepperEffect'));
            if (PE == None)
            {
               PE = Spawn(class'PepperEffect');
               if(PE != None)
					{
                  PE.Instigator=Instigator;
                  PE.HitLocation=HitLocation;
                  PE.GiveTo(P);
                  PE.Activate();
            	}
            }
      		return;
      	}
		}
	}
	foreach RadiusActors(class'Bot', B, 350, Start)
	{
		if ((B != self) && (B != None) && (B.PlayerReplicationInfo.Team != Pawn(Owner).PlayerReplicationInfo.Team))
      {
      	if ((B.Health > 0) && (B.FindInventoryType(class'PepperEffect') == None))
      	{
      		PE = PepperEffect(B.FindInventoryType(class'PepperEffect'));
            if (PE == None)
            {
               PE = Spawn(class'PepperEffect');
               if(PE != None)
					{
                  PE.Instigator=Instigator;
                  PE.HitLocation=HitLocation;
                  PE.GiveTo(B);
                  PE.Activate();
            	}
            }
      		return;
      	}
      }
	}
}

defaultproperties
{
   bRotatingPickup=True
   ExpireMessage="Pepper has worn off."
   bAutoActivate=True
   bActivatable=True
   bDisplayableInv=True
   PickupMessage="You have Pepper Power."
   ItemName="PepperMill"
   RespawnTime=120.000000
   PickupViewMesh=LodMesh'Peppermill'
   Charge=100
   MaxDesireability=1.200000
   PickupSound=Sound'UnrealShare.Pickups.GenPickSnd'
   ActivateSound=Sound'UnrealI.Pickups.Invisible'
   RemoteRole=ROLE_DumbProxy
   Mesh=LodMesh'Peppermill'
	CollisionRadius=20.000000
	CollisionHeight=30.000000
}