//
//visual class I created that is spawned when a projectile is blocked and destroyed by the frying pan
//gives a nice visual clue that you got a clean hit and destroyed it
class ProjectileFragments extends Fragment;

#exec TEXTURE IMPORT NAME=BurntMetal FILE=Textures\BurntMetal.bmp

//smoking effect
simulated function Tick(float DeltaTime)
{
   local UT_BlackSmoke b;

   if (FRand()<0.02)
   {
      b = Spawn(class'UT_BlackSmoke');
      b.DrawScale = FRand()*0.05+1.5;
      b.RemoteRole = ROLE_None;
   }
}

//rebound
simulated function CalcVelocity(vector Momentum, float ExplosionSize)
{
   Super.CalcVelocity(Momentum, ExplosionSize);
   Velocity.z += ExplosionSize/2;
}

defaultproperties
{
   Fragments(0)=LodMesh'UnrealShare.wfrag4'
   Fragments(1)=LodMesh'UnrealShare.wfrag5'
   Fragments(2)=LodMesh'UnrealShare.wfrag6'
   Fragments(3)=LodMesh'UnrealShare.wfrag7'
   Fragments(4)=LodMesh'UnrealShare.wfrag8'
   Fragments(5)=LodMesh'UnrealShare.wfrag9'
   numFragmentTypes=6
   ImpactSound=Sound'UnrealI.walkC'
   MiscSound=Sound'UnrealI.ChunkHit'
   Mesh=LodMesh'UnrealShare.wfrag4'
   CollisionRadius=12.000000
   CollisionHeight=2.000000
   Mass=5.000000
   Buoyancy=6.000000
   MultiSkins(0)=Texture'BurntMetal'
   MultiSkins(1)=Texture'BurntMetal'
   MultiSkins(2)=Texture'BurntMetal'
}