//
class Toastanator extends FFWeapon config(FoodFight);

//First person
#exec MESH IMPORT MESH=ToastenatorFix ANIVFILE=MODELS\ToastenatorFix_a.3D DATAFILE=MODELS\ToastenatorFix_d.3D X=0 Y=0 Z=0 UnMirror=1
#exec MESH ORIGIN MESH=ToastenatorFix X=-25 Y=-180 Z=-25 YAW=-11 ROLL=0 PITCH=0

#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=All        	STARTFRAME=0 		NUMFRAMES=268
#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=Still      	STARTFRAME=0     NUMFRAMES=1
#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=FireB      	STARTFRAME=1     NUMFRAMES=17
#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=Fire       	STARTFRAME=18    NUMFRAMES=18
#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=FullReload 	STARTFRAME=36    NUMFRAMES=212
#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=OneSlice  	STARTFRAME=170 NUMFRAMES=79
#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=DeSelect   	STARTFRAME=249   NUMFRAMES=6
#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=Down       	STARTFRAME=249   NUMFRAMES=6
#exec MESH SEQUENCE MESH=ToastenatorFix SEQ=Select     	STARTFRAME=255   NUMFRAMES=12

#exec TEXTURE IMPORT NAME=ToastenatorUVmap 			FILE=Textures/ToastenatorUVmap.bmp 			GROUP=Skins LODSET=2
#exec TEXTURE IMPORT NAME=SimpleGloveHandTexture 	FILE=Textures/SimpleGloveHandTexture.pcx 	GROUP=Skins LODSET=2

#exec MESHMAP SCALE      MESHMAP=ToastenatorFix  X=0.006 Y=0.006 Z=0.012
#exec MESHMAP SETTEXTURE MESHMAP=ToastenatorFix  NUM=0 TEXTURE=ToastenatorUVmap
#exec MESHMAP SETTEXTURE MESHMAP=ToastenatorFix  NUM=1 TEXTURE=SimpleGloveHandTexture
#exec MESHMAP SETTEXTURE MESHMAP=ToastenatorFix  NUM=2 TEXTURE=SimpleGloveHandTexture
#exec MESHMAP SETTEXTURE MESHMAP=ToastenatorFix  NUM=3 TEXTURE=ToastenatorUVmap
#exec MESHMAP SETTEXTURE MESHMAP=ToastenatorFix  NUM=4 TEXTURE=ToastProjUVmap

//Pickup
#exec MESH IMPORT MESH=ToastenatorPickup ANIVFILE=MODELS\ToastenatorPickup_a.3D DATAFILE=MODELS\ToastenatorPickup_d.3D X=0 Y=0 Z=0 LODSTYLE=12 UnMirror=1
#exec MESH ORIGIN MESH=ToastenatorPickup X=-90 Y=0 Z=50 YAW=0
#exec MESH LODPARAMS MESH=ToastenatorPickup  STRENGTH=0

#exec MESH SEQUENCE MESH=ToastenatorPickup SEQ=All   STARTFRAME=0  NUMFRAMES=1
#exec MESH SEQUENCE MESH=ToastenatorPickup SEQ=Still STARTFRAME=0  NUMFRAMES=1

#exec MESHMAP SCALE MESHMAP=ToastenatorPickup X=0.15 Y=0.15 Z=0.3
#exec MESHMAP SETTEXTURE MESHMAP=ToastenatorPickup NUM=1 TEXTURE=ToastenatorUVmap

//Third Person
#exec MESH IMPORT MESH=ToastenatorHand ANIVFILE=MODELS\ToastenatorPickup_a.3D DATAFILE=MODELS\ToastenatorPickup_d.3D X=0 Y=0 Z=0 LODSTYLE=12 UnMirror=1
#exec MESH ORIGIN MESH=ToastenatorHand X=0 Y=0 Z=0 YAW=0 PITCH=0 ROLL=0

#exec MESH SEQUENCE MESH=ToastenatorHand SEQ=All   STARTFRAME=0  NUMFRAMES=1
#exec MESH SEQUENCE MESH=ToastenatorHand SEQ=Still STARTFRAME=0  NUMFRAMES=1

#exec MESHMAP SCALE MESHMAP=ToastenatorHand X=0.1125 Y=0.1125 Z=0.225
#exec MESHMAP SETTEXTURE MESHMAP=ToastenatorHand NUM=1 TEXTURE=ToastenatorUVmap

//Sounds
#exec AUDIO IMPORT FILE="Sounds\ToasterFire.WAV" 			NAME=Springy 				GROUP=Toastanator
#exec AUDIO IMPORT FILE="Sounds\ToasterReload.WAV" 		NAME=ToasterReload 		GROUP=Toastanator
#exec AUDIO IMPORT FILE="Sounds\ToasterReloadOne.WAV" 	NAME=ToasterReloadOne 	GROUP=Toastanator
#exec AUDIO IMPORT FILE="Sounds\ToastSelect.WAV" 			NAME=ToastSelect 			GROUP=Toastanator

//Textures
#exec TEXTURE IMPORT NAME=ToasterIcon 	FILE=TEXTURES\ToasterIcon.bmp 	GROUP="Icons" MIPS=OFF
#exec TEXTURE IMPORT NAME=ToastReticle FILE=TEXTURES\ToastReticle.bmp 	GROUP="Icons" MIPS=OFF FLAGS=2 LODSET=2

var config bool ToastReticle;

function float RateSelf( out int bUseAltMode )
{
   if ((AmmoType != None) && (AmmoType.AmmoAmount <=0))
      return -2;
      
	//favors the primary fire
   if (FRand() < 0.7)
    	bUseAltMode = 0;
   else
   	bUseAltMode = 1;
   return (AIRating + FRand() * 0.05);
}

function float SuggestAttackStyle()
{
	return -0.3;
}

function float SuggestDefenseStyle()
{
	return -0.4;
}

function Fire(float Value)
{
	local Pawn P;

	if (AmmoType == None)
	{
		GiveAmmo(Pawn(Owner));
	}
	if (AmmoType.UseAmmo(1))
	{
		bCanClientFire = true;
      bPointing=True;
      P = Pawn(Owner);
      P.PlayRecoil(FiringSpeed);
		ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);
		ClientFire(Value);
		Gotostate('NormalFire');
	}
}

function AltFire(float Value)
{
	local Pawn P;

	if (AmmoType == None)
	{
		GiveAmmo(Pawn(Owner));
	}
 	if (AmmoType.UseAmmo(4))
	{
      bPointing=True;
      P = Pawn(Owner);
      P.PlayRecoil(FiringSpeed);
		FireRocketsA(AltProjectileClass, ProjectileSpeed, bWarnTarget);
		ClientAltFire(Value);
		Gotostate('AltFiring');
	}
	else if (AmmoType.UseAmmo(1))
   {
      bPointing=True;
      P = Pawn(Owner);
      P.PlayRecoil(FiringSpeed);
		ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);
		ClientAltFire(Value);
		Gotostate('NormalFire');
	}
}

function Projectile FireRocketsA( class<projectile> ProjClass, float ProjSpeed, bool bWarn )
{
	local Vector StartLoc, FireLocation, X,Y,Z;
	local rotator FireRot;
	local float Angle, RocketRad;
	local int RocketsLoaded;

	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
	StartLoc = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
	AdjustedAim = pawn(owner).AdjustAim(ProjSpeed, StartLoc, AimError, True, bWarn);	

	RocketsLoaded = 4;
   While ( RocketsLoaded > 0)
   {
		RocketRad = 1;
		Angle = 0;
		FireRot = AdjustedAim;
		FireLocation = StartLoc - (Sin(Angle)*RocketRad - 7.5)*Y + (Cos(Angle)*RocketRad - 7)*Z - X * 4 * FRand();
		FireRot.Pitch = AdjustedAim.Pitch - Angle * 600;
		// Top One
		Spawn(ProjClass,,, FireLocation , FireRot);
		RocketsLoaded--;

		Angle += 1.1;
		FireLocation = StartLoc - (Sin(Angle)*RocketRad - 7.5)*Y + (Cos(Angle)*RocketRad - 7)*Z - X * 4 * FRand();
		FireRot.Pitch = AdjustedAim.Pitch + 2 * (Angle * 600);
		// Bottom One
		Spawn(ProjClass,,, FireLocation , FireRot);
		RocketsLoaded--;

		FireRot.Yaw = AdjustedAim.Yaw - Angle * 600;
		FireLocation = StartLoc - (Sin(Angle)*RocketRad - 7.5)*Y + (Cos(Angle)*RocketRad - 7)*Z - X * 4 * FRand();
		FireRot.Pitch = AdjustedAim.Pitch + Angle * 600;
		//Left One
      Spawn(ProjClass,,, FireLocation , FireRot);
		RocketsLoaded--;

		Angle = -Angle;
		FireLocation = StartLoc - (Sin(Angle)*RocketRad - 7.5)*Y + (Cos(Angle)*RocketRad - 7)*Z - X * 4 * FRand();
		FireRot.Yaw = AdjustedAim.Yaw - Angle * 600;
		//Right One
		Spawn(ProjClass,,, FireLocation , FireRot);
		RocketsLoaded--;
  		Angle = -Angle;
	}
}

simulated function PlayFiring()
{
   PlayOwnedSound(FireSound, SLOT_None, Pawn(Owner).SoundDampening*3.0);
   PlayAnim('FireB', 2.0, 0.05);
}

simulated function PlayAltFiring()
{
   PlayOwnedSound(AltFireSound, SLOT_None, Pawn(Owner).SoundDampening*3.0);
   PlayAnim('FireB', 2.5, 0.05);
}

state NormalFire
{
	ignores Fire;

   function AnimEnd()
   {
      if (AnimSequence == 'FireB')
         if(AmmoType.AmmoAmount>=1)
         	PlayReloading();
   }

Begin:
	FinishAnim();
	if ((AmmoType != None) && (AmmoType.AmmoAmount<=0))
	{
		Gotostate('Idle');
	}
	Finish();
}

state ClientFiring
{
   simulated function AnimEnd()
   {
      if (AnimSequence == 'FireB')
         if(AmmoType.AmmoAmount>=1)
         	PlayReloading();
   }
}

state ClientAltFiring
{
   simulated function AnimEnd()
   {
      if (AnimSequence == 'FireB')
         if(AmmoType.AmmoAmount>=1)
        		PlayAltReloading();
   }
}

state AltFiring
{
	ignores AltFire;

   function AnimEnd()
   {
      if (AnimSequence == 'FireB')
      {
         if(AmmoType.AmmoAmount>=1)
         	PlayAltReloading();
      }
   }

Begin:
   FinishAnim();
   if ((AmmoType != None) && (AmmoType.AmmoAmount<=0))
      Gotostate('Idle');
   Finish();
}

simulated function PlayReloading()
{
	if (AmmoType.AmmoAmount > 0)
	{
   	PlayOwnedSound(Sound'ToasterReloadOne', SLOT_None, Pawn(Owner).SoundDampening*3.0);
   	PlayAnim('OneSlice',2.0,0.05);
	}
}

simulated function PlayAltReloading()
{
	if (AmmoType.AmmoAmount >= 4)
	{
   	PlayOwnedSound(Sound'ToasterReload', SLOT_None, Pawn(Owner).SoundDampening*3.0);
   	PlayAnim('FullReload',2.0,0.05);
   }
   else
   {
   	PlayOwnedSound(Sound'ToasterReloadOne', SLOT_None, Pawn(Owner).SoundDampening*3.0);
   	PlayAnim('OneSlice',2.0,0.05);
	}
}

simulated function PostRender(canvas C)
{
	local PlayerPawn P;
   local float Scale;
   local font CanvasFont;

   Super.PostRender(C);
   P = PlayerPawn(Owner);
   if ((P != None) && (ToastReticle))
   {
   	bOwnsCrossHair = true;
		Scale = C.ClipX/640;
		C.SetPos(0.5 * C.ClipX - 128 * Scale, 0.5 * C.ClipY - 128 * Scale );
		C.Style = ERenderStyle.STY_Translucent;
		C.DrawIcon(Texture'ToastReticle', Scale);
	}
}

defaultproperties
{
	ToastReticle=True
   WeaponDescription="Classification: Used to make toasts at home\n\nPrimary Fire: Loads up a single toast and fires it when real hot.\n\nSecondary Fire: Can launch four hot and sweet looking toasts to take out the whole team at once.."
   AmmoName=class'FoodFight.BreadPack'
   PickupAmmoCount=8
   bAltWarnTarget=True
   bRapidFire=False
   FiringSpeed=1.000000
   FireOffset=(X=12.000000,Y=-11.000000,Z=-6.000000)
   ProjectileClass=class'FoodFight.BreadSlice'
   AltProjectileClass=class'FoodFight.BreadSlice'
   AIRating=0.600000
   RefireRate=1.00000
   AltRefireRate=1.00000
   FireSound=Sound'Springy'
   AltFireSound=Sound'Springy'
   SelectSound=Sound'ToastSelect'
   DeathMessage="%o was toasted! %k makes really tasty stuff at home."
   AutoSwitchPriority=2
   InventoryGroup=9
   PickupMessage="You got the Toastanator."
   ItemName="Toastanator"
   PlayerViewOffset=(X=1.700000,Y=-0.850000,Z=-0.950000)
   PlayerViewMesh=ToastenatorFix
   BobDamping=0.972000
   PickupViewMesh=ToastenatorPickup
   ThirdPersonMesh=ToastenatorHand
   StatusIcon=ToasterIcon
   PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
   Icon=ToasterIcon
   Mesh=ToastenatorPickup
   bNoSmooth=False
   CollisionHeight=25.000000
}
