//
//lunchbox pickup that gives random awards
class lunchbox extends PickUp;

#exec mesh import mesh=lunchbox anivfile=Models\lunchbox_a.3d datafile=Models\lunchbox_d.3d x=0 y=0 z=0
#exec mesh origin mesh=lunchbox x=0 y=0 z=0 YAW=0 PITCH=-64 ROLL=-60
#exec MESH LODPARAMS MESH=lunchbox STRENGTH=0

#exec mesh sequence mesh=lunchbox seq=All startframe=0 numframes=1

#exec meshmap new meshmap=lunchbox mesh=lunchbox
#exec meshmap scale meshmap=lunchbox x=0.036135 y=0.041555 z=0.07227

#exec TEXTURE IMPORT NAME=BrushedMetal FILE=Textures/BrushedMetal.bmp GROUP=Skins

var() class<ammo> AmmoName;
var travel ammo AmmoType;
var int HalaCount;

auto state Pickup
{
   function Touch(actor Other)
   {
      local Pawn P;
      local inventory Inv;

      if (ValidTouch(Other))
      {
         P = Pawn(Other);
         //random award
         if ( FRand() < 0.50)
         {
         	//does the player already have one?
         	Inv = P.FindInventoryType(class'Brocconade');
   			if (Inv == None)
   			{
   				//Nope, he doesn't so give him one
					GiveWeapon(P,class'FoodFight.Brocconade');
					P.ReceiveLocalizedMessage(class'PickupMessageOne');
				}
         	else
         	{
         		//player already has one, lets give him something else then
					P.Health += 10;
					P.ReceiveLocalizedMessage(class'PickupMessageThree');
				}
			}
			else
			{
         	Inv = Pawn(Other).FindInventoryType(class'HalapenjoCan');
   			if (Inv == None)
				{
					AmmoType = Spawn(class'FoodFight.HalapenjoCan');
					Pawn(Other).AddInventory(AmmoType);
      			AmmoType.BecomeItem();
      			AmmoType.AmmoAmount = HalaCount;
      			AmmoType.GotoState('Idle2');
      			P.ReceiveLocalizedMessage(class'PickupMessageTwo');
         	}
         	else
         	{
					P.Health += 10;
					P.ReceiveLocalizedMessage(class'PickupMessageThree');
				}
			}
         PlaySound (PickupSound,,2.5);
         SetRespawn();
      }
   }
}

//Slightly altered giveweapon
function GiveWeapon(Pawn PlayerPawn, class<TournamentWeapon> WeaponClass)
{
   local Weapon NewWeapon;

   if(PlayerPawn.FindInventoryType(WeaponClass) != None)
      return;
   newWeapon = Spawn(WeaponClass);
   if(newWeapon != None)
   {
      newWeapon.RespawnTime = 0.0;
      newWeapon.bHeldItem = true;
      newWeapon.GiveTo(PlayerPawn);
      newWeapon.SetSwitchPriority(PlayerPawn);
      newWeapon.WeaponSet(PlayerPawn);
	 	newWeapon.GiveAmmo(PlayerPawn);
		if (NewWeapon.Ammotype != None)
	 		newWeapon.AmmoType.AmmoAmount = newWeapon.AmmoType.MaxAmmo;
   }
}

defaultproperties
{
	HalaCount=7
	RespawnTime=60.000000
	PickupSound=Sound'UnrealShare.Pickups.Health2'
	RemoteRole=ROLE_DumbProxy
	AmbientGlow=64
	bRotatingPickup=True
	PickupViewMesh=Mesh'lunchbox'
  	DrawType=DT_Mesh
  	Mesh=Mesh'lunchbox'
  	bCollideWhenPlacing=True
  	bCollideActors=True
  	bCollideWorld=True
  	bBlockActors=True
  	bBlockPlayers=True
  	CollisionRadius=20.00000
  	CollisionHeight=22.00000
  	MultiSkins(0)=Texture'Blackness'
  	MultiSkins(1)=Texture'BrushedMetal'
  	MultiSkins(2)=Texture'BotPack.Skins.JpflagR'
  	MultiSkins(3)=Texture'BotPack.Skins.JpflagB'
}
